/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_PSImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 1);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern10 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern10 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern10 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern10 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      res = pattern18 (x3);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern19 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 23
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != UNSPEC
      || XVECLEN (x9, 0) != 1
      || XINT (x9, 1) != 1)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24)
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 26
      || GET_MODE (x13) != E_HImode)
    return -1;
  x14 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 30
      || GET_MODE (x15) != E_HImode)
    return -1;
  x16 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 0
      || GET_MODE (x17) != E_QImode)
    return -1;
  x18 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 24
      || GET_MODE (x19) != E_HImode)
    return -1;
  x20 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 23
      || GET_MODE (x21) != E_QImode)
    return -1;
  x22 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != MEM
      || GET_MODE (x23) != E_QImode)
    return -1;
  x24 = XVECEXP (x9, 0, 0);
  operands[0] = x24;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x25 = XEXP (x23, 0);
  operands[1] = x25;
  if (!io_address_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x11))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern52 (x3, 
E_QImode); /* [-1, 0] */

    case E_QQmode:
      if (pattern52 (x3, 
E_QQmode) != 0)
        return -1;
      return 1;

    case E_UQQmode:
      if (pattern52 (x3, 
E_UQQmode) != 0)
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_PSImode:
      if (pattern53 (x3, pnum_clobbers, 
E_QImode) != 0)
        return -1;
      return 8;

    case E_SImode:
      if (pattern52 (x3, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_SQmode:
      if (pattern52 (x3, 
E_SQmode) != 0)
        return -1;
      return 10;

    case E_USQmode:
      if (pattern52 (x3, 
E_USQmode) != 0)
        return -1;
      return 11;

    case E_SAmode:
      if (pattern52 (x3, 
E_SAmode) != 0)
        return -1;
      return 12;

    case E_USAmode:
      if (pattern52 (x3, 
E_USAmode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      return pattern69 (x1); /* [-1, 6] */

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      res = pattern70 (x1);
      if (res >= 0)
        return res + 7; /* [7, 13] */
      return -1;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      return 0;

    case SIGN_EXTEND:
      return 1;

    case ZERO_EXTEND:
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[1] = x7;
  if (!const_0_to_7_operand (operands[1], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[4] = x9;
  if (!const_int_operand (operands[4], E_QImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[3] = x10;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern104 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != LO_SUM
      || GET_MODE (x1) != E_PSImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 30
      || GET_MODE (x3) != E_HImode)
    return -1;
  return 0;
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern108 (x1, 
E_HImode); /* [-1, 0] */

    case E_PSImode:
      if (pattern108 (x1, 
E_PSImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern108 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 2
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  return 0;
}

int
pattern125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  return 0;
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern83 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern83 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_PSImode:
      if (pattern83 (x1, 
E_PSImode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (pattern83 (x1, 
E_SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern134 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[3], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 2);
  operands[2] = x4;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern134 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern134 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern134 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern134 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1
      || pattern141 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern146 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QQmode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QQmode))
    return -1;
  return 0;
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nop_general_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode
          || !register_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode
          || !register_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern181 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[2] = x2;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern180 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern180 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern180 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern180 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 3;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 4;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 5;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 6;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 7;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 8;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 9;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern213 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != IF_THEN_ELSE)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  return 0;
}

int
pattern222 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != ZERO_EXTEND
      || GET_MODE (x2) != E_HImode
      || pattern221 (x1, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern224 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[2], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern232 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case MEM:
      if (GET_MODE (x1) != E_QImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      if (!low_io_address_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[0] = x1;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode
      || GET_MODE (x2) != E_QImode)
    return -1;
  return 0;
}

int
pattern240 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[3], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 0;

    case SIGN_EXTEND:
      if (pattern239 (x1) != 0)
        return -1;
      return 1;

    case ZERO_EXTEND:
      if (pattern239 (x1) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || GET_MODE (x5) != E_UDQmode)
            return -1;
          return 0;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || GET_MODE (x5) != E_UDAmode)
            return -1;
          return 1;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || GET_MODE (x5) != E_UTAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || !const_operand (operands[0], E_UDQmode))
            return -1;
          return 3;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || !const_operand (operands[0], E_UDAmode))
            return -1;
          return 4;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || !const_operand (operands[0], E_UTAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern256 (x5, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!scratch_operand (operands[3], E_HImode))
            return -1;
          return 1;

        case E_QImode:
          if (!scratch_operand (operands[3], E_QImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_PSImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern256 (x5, 
E_PSImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern268 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  return 0;
}

int
pattern277 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x11;
      return pattern274 (); /* [-1, 1] */

    case SIGN_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern276 (x12);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case ZERO_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern276 (x12);
      if (res >= 0)
        return res + 6; /* [6, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern294 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_HImode))
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_HImode))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !scratch_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !scratch_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern305 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern311 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 22
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 18
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  if (REGNO (x10) != 30
      || GET_MODE (x10) != E_HImode
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern323 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2
      || pattern322 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern326 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != COMPARE
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern334 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !d_register_operand (operands[1], i1)
      || XVECLEN (x1, 0) != 3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x3, 0);
  operands[3] = x7;
  if (!d_register_operand (operands[3], E_QImode))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  switch (GET_CODE (x6))
    {
    case PLUS:
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 0;

    case IOR:
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 1;

    case AND:
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern348 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 22:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XVECEXP (x1, 0, 3);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) != 23
          || GET_MODE (x9) != E_QImode)
        return -1;
      x10 = XVECEXP (x1, 0, 4);
      x11 = XEXP (x10, 0);
      if (REGNO (x11) != 24
          || GET_MODE (x11) != E_QImode)
        return -1;
      x12 = XVECEXP (x1, 0, 5);
      x13 = XEXP (x12, 0);
      if (REGNO (x13) != 25
          || GET_MODE (x13) != E_QImode
          || pattern139 (x1, 
E_QImode) != 0)
        return -1;
      return 0;

    case 21:
      if (GET_MODE (x7) != E_QImode
          || pattern347 (x1, 
E_HImode, 
26, 
24) != 0)
        return -1;
      return 1;

    case 18:
      if (GET_MODE (x7) != E_SImode
          || pattern347 (x1, 
E_SImode, 
30, 
26) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern363 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4
      || GET_MODE (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern368 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (REGNO (x6) != i2
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (REGNO (x10) != i2
      || GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern379 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2
      || pattern141 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern385 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  if (!const_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern356 (x3); /* [-1, 0] */
}

int
pattern389 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return 0;

    case E_PSImode:
      return 1;

    case E_SImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern396 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern394 (x1); /* [-1, 0] */

    case NE:
      if (pattern394 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern394 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern394 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern394 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern394 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LO_SUM
      || GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      if (
#line 640 "../../gcc/config/avr/avr.md"
(1 == 1
   && avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)))
        return 50; /* xmovqi_8 */
      if (pnum_clobbers == NULL
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 53; /* fmovqi */

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x2) != E_QQmode)
        return -1;
      if (
#line 640 "../../gcc/config/avr/avr.md"
(1 == 1
   && avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)))
        return 51; /* xmovqq_8 */
      if (pnum_clobbers == NULL
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 54; /* fmovqq */

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x2) != E_UQQmode)
        return -1;
      if (
#line 640 "../../gcc/config/avr/avr.md"
(1 == 1
   && avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)))
        return 52; /* xmovuqq_8 */
      if (pnum_clobbers == NULL
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 55; /* fmovuqq */

    case E_HImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 56; /* fmovhi */

    case E_HQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_HQmode)
          || GET_MODE (x2) != E_HQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 57; /* fmovhq */

    case E_UHQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_UHQmode)
          || GET_MODE (x2) != E_UHQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 58; /* fmovuhq */

    case E_HAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_HAmode)
          || GET_MODE (x2) != E_HAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 59; /* fmovha */

    case E_UHAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_UHAmode)
          || GET_MODE (x2) != E_UHAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 60; /* fmovuha */

    case E_SImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 61; /* fmovsi */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SQmode)
          || GET_MODE (x2) != E_SQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 62; /* fmovsq */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_USQmode)
          || GET_MODE (x2) != E_USQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 63; /* fmovusq */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SAmode)
          || GET_MODE (x2) != E_SAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 64; /* fmovsa */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_USAmode)
          || GET_MODE (x2) != E_USAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 65; /* fmovusa */

    case E_SFmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 66; /* fmovsf */

    case E_PSImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 67; /* fmovpsi */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern196 (x2) != 0)
            return -1;
          if (
#line 2469 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 479; /* umulqihi3_split */
          if (pnum_clobbers == NULL
              || !
#line 2482 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 481; /* umulqihi3 */

        case E_SImode:
          if (pnum_clobbers == NULL
              || !pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              switch (pattern198 (
E_QImode))
                {
                case 0:
                  if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 551; /* *uumulqiqisi3 */

                case 1:
                  if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 559; /* *uumulqihisi3 */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern198 (
E_HImode))
                {
                case 0:
                  if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 555; /* *uumulhiqisi3 */

                case 1:
                  if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 563; /* *uumulhihisi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_PSImode:
          switch (pattern197 (x2))
            {
            case 0:
              if (
#line 4112 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 596; /* *umulqihipsi3_split */
              if (pnum_clobbers == NULL
                  || !
#line 4125 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 597; /* *umulqihipsi3 */

            case 1:
              if (
#line 4139 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 598; /* *umulhiqipsi3_split */
              if (pnum_clobbers == NULL
                  || !
#line 4152 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 599; /* *umulhiqipsi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern199 (x2, pnum_clobbers))
        {
        case 0:
          if (
#line 2492 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 482; /* usmulqihi3 */
          if (pnum_clobbers == NULL
              || !
#line 2505 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 483; /* *usmulqihi3 */

        case 1:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 549; /* *usmulqiqisi3 */

        case 2:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 557; /* *usmulqihisi3 */

        case 3:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 553; /* *usmulhiqisi3 */

        case 4:
          if (!
#line 3650 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 561; /* *usmulhihisi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      if (register_operand (operands[0], E_HImode))
        {
          res = recog_11 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x3;
      if (!pseudo_register_or_const_int_operand (operands[2], E_SImode)
          || !pseudo_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!pseudo_register_operand (operands[1], E_QImode)
              || !
#line 3487 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 543; /* *muluqisi3 */

        case E_HImode:
          if (!pseudo_register_operand (operands[1], E_HImode)
              || !
#line 3487 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 544; /* *muluhisi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_9 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != REG)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (REGNO (x3))
        {
        case 24:
          if (pnum_clobbers == NULL)
            return -1;
          switch (REGNO (x4))
            {
            case 22:
              if (REGNO (x5) != 24)
                return -1;
              switch (GET_MODE (x5))
                {
                case E_QImode:
                  if (GET_MODE (x2) != E_QImode
                      || GET_MODE (x3) != E_QImode
                      || GET_MODE (x4) != E_QImode)
                    return -1;
                  if (
#line 2243 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                    {
                      *pnum_clobbers = 1;
                      return 302; /* *mulqi3_call_split */
                    }
                  if (!
#line 2256 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 303; /* *mulqi3_call */

                case E_HImode:
                  if (GET_MODE (x2) != E_HImode
                      || GET_MODE (x3) != E_HImode
                      || GET_MODE (x4) != E_HImode)
                    return -1;
                  if (
#line 3319 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                    {
                      *pnum_clobbers = 2;
                      return 539; /* *mulhi3_call_split */
                    }
                  if (!
#line 3334 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                    return -1;
                  *pnum_clobbers = 3;
                  return 540; /* *mulhi3_call */

                default:
                  return -1;
                }

            case 25:
              if (GET_MODE (x4) != E_QQmode
                  || pattern200 (x1, 
E_QQmode, 
23) != 0)
                return -1;
              if (
#line 377 "../../gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 2;
                  return 3080; /* *mulqq3.call_split */
                }
              if (!
#line 394 "../../gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 3;
              return 3081; /* *mulqq3.call */

            default:
              return -1;
            }

        case 22:
          if (pnum_clobbers == NULL
              || REGNO (x4) != 18
              || REGNO (x5) != 22)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_SImode)
                return -1;
              if (
#line 3719 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 564; /* *mulsi3_call_split */
                }
              if (
#line 3735 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY))
                {
                  *pnum_clobbers = 3;
                  return 565; /* *mulsi3_call_pr118012_split */
                }
              if (
#line 3754 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                {
                  *pnum_clobbers = 2;
                  return 566; /* *mulsi3_call */
                }
              if (!
#line 3766 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && reload_completed))
                return -1;
              *pnum_clobbers = 4;
              return 567; /* *mulsi3_call_pr118012 */

            case E_PSImode:
              if (GET_MODE (x2) != E_PSImode
                  || GET_MODE (x3) != E_PSImode
                  || GET_MODE (x4) != E_PSImode)
                return -1;
              if (
#line 4253 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 3;
                  return 604; /* *mulpsi3.libgcc_split */
                }
              if (!
#line 4272 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 4;
              return 605; /* *mulpsi3.libgcc */

            default:
              return -1;
            }

        case 18:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern24 (x1, 
26))
            {
            case 0:
              if (
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3082; /* *mulhq3.call_split */
                }
              if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3086; /* *mulhq3.call */

            case 1:
              if (
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3083; /* *muluhq3.call_split */
                }
              if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3087; /* *muluhq3.call */

            case 2:
              if (
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3084; /* *mulha3.call_split */
                }
              if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3088; /* *mulha3.call */

            case 3:
              if (
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3085; /* *muluha3.call_split */
                }
              if (!
#line 440 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3089; /* *muluha3.call */

            default:
              return -1;
            }

        case 16:
          if (REGNO (x4) != 20)
            return -1;
          switch (pattern25 (x1, 
24))
            {
            case 0:
              if (
#line 468 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return 3090; /* *mulsa3.call_split */
              if (pnum_clobbers == NULL
                  || !
#line 481 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 3092; /* *mulsa3.call */

            case 1:
              if (
#line 468 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return 3091; /* *mulusa3.call_split */
              if (pnum_clobbers == NULL
                  || !
#line 481 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 3093; /* *mulusa3.call */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          if (pnum_clobbers != NULL)
            {
              res = recog_10 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          res = recog_12 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG)
            return -1;
          switch (pattern133 (x1))
            {
            case 0:
              if (
#line 3779 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 569; /* *umulhisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3792 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 571; /* *umulhisi3_call */

            case 1:
              if (
#line 3829 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 576; /* *usmulhisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3842 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 577; /* *usmulhisi3_call */

            case 2:
              if (
#line 3850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 579; /* *muluhisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3863 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 581; /* *muluhisi3_call */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1434; /* *map.mul.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1436; /* *map.mul.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1440; /* *map.mul.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1438; /* *map.mul.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1442; /* *map.mul.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1444; /* *map.mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x6) != REG)
            return -1;
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) != REG)
            return -1;
          switch (REGNO (x6))
            {
            case 18:
              x4 = XEXP (x2, 1);
              if (GET_CODE (x4) != SIGN_EXTEND)
                return -1;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG)
                return -1;
              switch (REGNO (x7))
                {
                case 26:
                  if (pattern261 (x1, 
E_SImode, 
E_HImode, 
22) != 0)
                    return -1;
                  if (
#line 3779 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                    return 568; /* *mulhisi3_call_split */
                  if (pnum_clobbers == NULL
                      || !
#line 3792 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                    return -1;
                  *pnum_clobbers = 1;
                  return 570; /* *mulhisi3_call */

                case 22:
                  if (pnum_clobbers == NULL
                      || pattern261 (x1, 
E_DImode, 
E_SImode, 
18) != 0)
                    return -1;
                  if (
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
                    {
                      *pnum_clobbers = 2;
                      return 3360; /* mulsidi3_insn */
                    }
                  if (!
#line 693 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL
   && reload_completed))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3362; /* *mulsidi3_insn */

                default:
                  return -1;
                }

            case 26:
              if (pattern201 (x1, 
E_SImode, 
22, 
18, 
E_HImode) != 0)
                return -1;
              if (
#line 3850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 578; /* *mulshisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3863 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 580; /* *mulshisi3_call */

            case 25:
              if (pattern201 (x1, 
E_PSImode, 
18, 
22, 
E_QImode) != 0)
                return -1;
              if (
#line 4229 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 602; /* *mulsqipsi3.libgcc_split */
              if (pnum_clobbers == NULL
                  || !
#line 4242 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 603; /* *mulsqipsi3.libgcc */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1433; /* *map.mul.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1435; /* *map.mul.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1439; /* *map.mul.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1437; /* *map.mul.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1441; /* *map.mul.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1443; /* *map.mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ZERO_EXTEND)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != NOT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      res = recog_15 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_MODE (x8) != E_HImode
          || pattern163 (x1) != 0)
        return -1;
      if (
#line 3871 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 582; /* *mulohisi3_call_split */
      if (pnum_clobbers == NULL
          || !
#line 3884 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 583; /* *mulohisi3_call */

    case AND:
      switch (pattern33 (x1))
        {
        case 0:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1413; /* *map.mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1417; /* *map.mul.and1-to-skip.qi */

        case 2:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1421; /* *map.mul.and1-to-skip.qi */

        case 3:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1425; /* *map.mul.and1-to-skip.qi */

        case 4:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1414; /* *map.mul.and1-to-skip.hi */

        case 5:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1418; /* *map.mul.and1-to-skip.hi */

        case 6:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1422; /* *map.mul.and1-to-skip.hi */

        case 7:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1426; /* *map.mul.and1-to-skip.hi */

        case 8:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1415; /* *map.mul.and1-to-skip.psi */

        case 9:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1419; /* *map.mul.and1-to-skip.psi */

        case 10:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1423; /* *map.mul.and1-to-skip.psi */

        case 11:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1427; /* *map.mul.and1-to-skip.psi */

        case 12:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1416; /* *map.mul.and1-to-skip.si */

        case 13:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1420; /* *map.mul.and1-to-skip.si */

        case 14:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1424; /* *map.mul.and1-to-skip.si */

        case 15:
          if (!
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1428; /* *map.mul.and1-to-skip.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) == 22)
    {
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) == REG
          && REGNO (x5) == 36
          && GET_MODE (x5) == E_CCmode)
        {
          x6 = XEXP (x2, 1);
          operands[0] = x6;
          switch (GET_MODE (x3))
            {
            case E_QImode:
              if (memory_operand (operands[0], E_QImode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 20; /* *load_qi_libgcc */
              break;

            case E_QQmode:
              if (memory_operand (operands[0], E_QQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 21; /* *load_qq_libgcc */
              break;

            case E_UQQmode:
              if (memory_operand (operands[0], E_UQQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 22; /* *load_uqq_libgcc */
              break;

            case E_HImode:
              if (memory_operand (operands[0], E_HImode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 23; /* *load_hi_libgcc */
              break;

            case E_HQmode:
              if (memory_operand (operands[0], E_HQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 24; /* *load_hq_libgcc */
              break;

            case E_UHQmode:
              if (memory_operand (operands[0], E_UHQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 25; /* *load_uhq_libgcc */
              break;

            case E_HAmode:
              if (memory_operand (operands[0], E_HAmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 26; /* *load_ha_libgcc */
              break;

            case E_UHAmode:
              if (memory_operand (operands[0], E_UHAmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 27; /* *load_uha_libgcc */
              break;

            case E_SImode:
              if (memory_operand (operands[0], E_SImode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 28; /* *load_si_libgcc */
              break;

            case E_SQmode:
              if (memory_operand (operands[0], E_SQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 29; /* *load_sq_libgcc */
              break;

            case E_USQmode:
              if (memory_operand (operands[0], E_USQmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 30; /* *load_usq_libgcc */
              break;

            case E_SAmode:
              if (memory_operand (operands[0], E_SAmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 31; /* *load_sa_libgcc */
              break;

            case E_USAmode:
              if (memory_operand (operands[0], E_USAmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 32; /* *load_usa_libgcc */
              break;

            case E_SFmode:
              if (memory_operand (operands[0], E_SFmode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 33; /* *load_sf_libgcc */
              break;

            case E_PSImode:
              if (memory_operand (operands[0], E_PSImode)
                  && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
                return 34; /* *load_psi_libgcc */
              break;

            default:
              break;
            }
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x3;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!l_register_operand (operands[0], E_HImode)
          || !immediate_operand (operands[1], E_HImode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 123; /* *reload_inhi */

    case E_HQmode:
      if (!l_register_operand (operands[0], E_HQmode)
          || !immediate_operand (operands[1], E_HQmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 124; /* *reload_inhq */

    case E_UHQmode:
      if (!l_register_operand (operands[0], E_UHQmode)
          || !immediate_operand (operands[1], E_UHQmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 125; /* *reload_inuhq */

    case E_HAmode:
      if (!l_register_operand (operands[0], E_HAmode)
          || !immediate_operand (operands[1], E_HAmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 126; /* *reload_inha */

    case E_UHAmode:
      if (!l_register_operand (operands[0], E_UHAmode)
          || !immediate_operand (operands[1], E_UHAmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 127; /* *reload_inuha */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || pattern206 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
          switch (pattern337 (x3))
            {
            case 0:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3173; /* *adddi3_insn */

            case 1:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3174; /* *adddq3_insn */

            case 2:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3175; /* *addudq3_insn */

            case 3:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3176; /* *addda3_insn */

            case 4:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3177; /* *adduda3_insn */

            case 5:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3178; /* *addta3_insn */

            case 6:
              if (!
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3179; /* *adduta3_insn */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern303 (x6, 
E_QImode, 
26, 
E_DImode) != 0)
            return -1;
          x7 = XEXP (x3, 0);
          if (GET_MODE (x7) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode
              || !
#line 135 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3181; /* *adddi3_const8_insn */

        case CONST_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
          switch (pattern338 (x3))
            {
            case 0:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3189; /* *adddi3_const_insn */

            case 1:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3190; /* *adddq3_const_insn */

            case 2:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3191; /* *addudq3_const_insn */

            case 3:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3192; /* *addda3_const_insn */

            case 4:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3193; /* *adduda3_const_insn */

            case 5:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3194; /* *addta3_const_insn */

            case 6:
              if (!
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3195; /* *adduta3_const_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 36
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern291 (x4))
            {
            case 0:
              if (!
#line 1653 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 181; /* *addhi3_zero_extend */

            case 1:
              if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 237; /* *addpsi3.zero_extend.qi */

            case 2:
              if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 241; /* *addpsi3.zero_extend.hi */

            case 3:
              if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 239; /* *addsi3.zero_extend.qi */

            case 4:
              if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 243; /* *addsi3.zero_extend.hi */

            case 5:
              if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 245; /* *addsi3.zero_extend.psi */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x6;
          if (!const_m255_to_m1_operand (operands[2], E_HImode)
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 1697 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 185; /* *addhi3_zero_extend.const */

        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_QImode))
            return -1;
          x10 = XEXP (x6, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_QImode)
              || !
#line 1766 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 190; /* *usum_widenqihi3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND
          || GET_MODE (x9) != E_HImode)
        return -1;
      x11 = XEXP (x5, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern169 (x1, 
E_HImode) != 0)
        return -1;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 1738 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 188; /* *addhi3_zero_extend.ashift1 */

    case SIGN_EXTEND:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 36
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern291 (x4))
        {
        case 0:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1
   && (2 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 235; /* *addhi3.sign_extend.qi */

        case 1:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 236; /* *addpsi3.sign_extend.qi */

        case 2:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 240; /* *addpsi3.sign_extend.hi */

        case 3:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 238; /* *addsi3.sign_extend.qi */

        case 4:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 242; /* *addsi3.sign_extend.hi */

        case 5:
          if (!
#line 1998 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 244; /* *addsi3.sign_extend.psi */

        default:
          return -1;
        }

    case GE:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 380; /* *addqi3.ge0 */

        case 1:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 388; /* *addqi3.ge0 */

        case 2:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 396; /* *addqi3.ge0 */

        case 3:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 404; /* *addqi3.ge0 */

        case 4:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 382; /* *addhi3.ge0 */

        case 5:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 390; /* *addhi3.ge0 */

        case 6:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 398; /* *addhi3.ge0 */

        case 7:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 406; /* *addhi3.ge0 */

        case 8:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 384; /* *addpsi3.ge0 */

        case 9:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 392; /* *addpsi3.ge0 */

        case 10:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 400; /* *addpsi3.ge0 */

        case 11:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 408; /* *addpsi3.ge0 */

        case 12:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 386; /* *addsi3.ge0 */

        case 13:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 394; /* *addsi3.ge0 */

        case 14:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 402; /* *addsi3.ge0 */

        case 15:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 410; /* *addsi3.ge0 */

        default:
          return -1;
        }

    case LT:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 381; /* *addqi3.lt0 */

        case 1:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 389; /* *addqi3.lt0 */

        case 2:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 397; /* *addqi3.lt0 */

        case 3:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 405; /* *addqi3.lt0 */

        case 4:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 383; /* *addhi3.lt0 */

        case 5:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 391; /* *addhi3.lt0 */

        case 6:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 399; /* *addhi3.lt0 */

        case 7:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 407; /* *addhi3.lt0 */

        case 8:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 385; /* *addpsi3.lt0 */

        case 9:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 393; /* *addpsi3.lt0 */

        case 10:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 401; /* *addpsi3.lt0 */

        case 11:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 409; /* *addpsi3.lt0 */

        case 12:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 387; /* *addsi3.lt0 */

        case 13:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 395; /* *addsi3.lt0 */

        case 14:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 403; /* *addsi3.lt0 */

        case 15:
          if (!
#line 2390 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 411; /* *addsi3.lt0 */

        default:
          return -1;
        }

    case MULT:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          if (pattern237 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          operands[2] = x11;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x8 = XEXP (x2, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 36
                  || GET_MODE (x8) != E_CCmode
                  || !
#line 2611 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 491; /* *maddqi4 */

            case CONST_INT:
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2649 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 494; /* *maddqi4.const */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern238 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          switch (GET_CODE (x11))
            {
            case SIGN_EXTEND:
              if (pattern361 (x1) != 0
                  || !
#line 2720 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 498; /* *maddqihi4 */

            case ZERO_EXTEND:
              if (pattern361 (x1) != 0
                  || !
#line 2780 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              return 507; /* *sumsubqihi4 */

            case CONST_INT:
              operands[2] = x11;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode))
                return -1;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2859 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 513; /* *maddqihi4.sconst */
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2951 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              return 519; /* *sumaddqihi4.uconst */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern238 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          switch (GET_CODE (x11))
            {
            case ZERO_EXTEND:
              if (pattern361 (x1) != 0
                  || !
#line 2720 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 499; /* *umaddqihi4 */

            case SIGN_EXTEND:
              if (pattern361 (x1) != 0
                  || !
#line 2780 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              return 506; /* *usmsubqihi4 */

            case CONST_INT:
              operands[2] = x11;
              if (!u8_operand (operands[2], E_HImode))
                return -1;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2859 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 514; /* *umaddqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      x4 = XEXP (x3, 0);
      if (pattern104 (x4, 
21) != 0
          || pattern172 (x1, 
21, 
22, 
E_QImode) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern382 (x1))
        {
        case 0:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 83; /* fxload_qi_libgcc */

        case 1:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 84; /* fxload_qq_libgcc */

        case 2:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 85; /* fxload_uqq_libgcc */

        case 3:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 86; /* fxload_hi_libgcc */

        case 4:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 87; /* fxload_hq_libgcc */

        case 5:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 88; /* fxload_uhq_libgcc */

        case 6:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 89; /* fxload_ha_libgcc */

        case 7:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 90; /* fxload_uha_libgcc */

        case 8:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 91; /* fxload_si_libgcc */

        case 9:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 92; /* fxload_sq_libgcc */

        case 10:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 93; /* fxload_usq_libgcc */

        case 11:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 94; /* fxload_sa_libgcc */

        case 12:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 95; /* fxload_usa_libgcc */

        case 13:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 96; /* fxload_sf_libgcc */

        case 14:
          if (!
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 97; /* fxload_psi_libgcc */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_78 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern174 (x1) != 0)
        return -1;
      x7 = XEXP (x2, 0);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          *pnum_clobbers = 2;
          return 168; /* *clrmemqi_split */

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          *pnum_clobbers = 2;
          return 170; /* *clrmemhi_split */

        default:
          return -1;
        }

    case PLUS:
      return recog_82 (x1, insn, pnum_clobbers);

    case MINUS:
      if (pattern105 (x1) != 0
          || !scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern315 (x3, 
E_HImode) != 0
              || !
#line 2152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 285; /* *subhi3 */

        case E_HQmode:
          if (pattern315 (x3, 
E_HQmode) != 0
              || !
#line 2152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 286; /* *subhq3 */

        case E_UHQmode:
          if (pattern315 (x3, 
E_UHQmode) != 0
              || !
#line 2152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 287; /* *subuhq3 */

        case E_HAmode:
          if (pattern315 (x3, 
E_HAmode) != 0
              || !
#line 2152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 288; /* *subha3 */

        case E_UHAmode:
          if (pattern315 (x3, 
E_UHAmode) != 0
              || !
#line 2152 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 289; /* *subuha3 */

        case E_SImode:
          if (pattern315 (x3, 
E_SImode) != 0
              || !
#line 2182 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 295; /* *subsi3 */

        case E_SQmode:
          if (pattern315 (x3, 
E_SQmode) != 0
              || !
#line 2182 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 296; /* *subsq3 */

        case E_USQmode:
          if (pattern315 (x3, 
E_USQmode) != 0
              || !
#line 2182 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 297; /* *subusq3 */

        case E_SAmode:
          if (pattern315 (x3, 
E_SAmode) != 0
              || !
#line 2182 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 298; /* *subsa3 */

        case E_USAmode:
          if (pattern315 (x3, 
E_USAmode) != 0
              || !
#line 2182 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 299; /* *subusa3 */

        default:
          return -1;
        }

    case MULT:
      return recog_80 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      if (pattern107 (x2, 
24, 
E_HImode) != 0
          || pattern106 (x1) != 0)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case LSHIFTRT:
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != MULT
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x4, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || pattern363 (x1, 
E_CCmode, 
36, 
E_HImode, 
22) != 0)
            return -1;
          switch (pattern365 (x11))
            {
            case 0:
              if (!
#line 3821 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 574; /* *smulhi3_highpart_call */

            case 1:
              if (!
#line 3821 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 575; /* *umulhi3_highpart_call */

            default:
              return -1;
            }

        case CLZ:
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 22
              || GET_MODE (x11) != E_SImode
              || pattern363 (x1, 
E_CCmode, 
36, 
E_QImode, 
26) != 0
              || !
#line 9455 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1042; /* *clzsihi2.libgcc */

        case CTZ:
          if (pattern341 (x1) != 0)
            return -1;
          return 1045; /* *ctzsihi2.libgcc_split */

        case FFS:
          if (pattern341 (x1) != 0)
            return -1;
          return 1049; /* *ffssihi2.libgcc_split */

        default:
          return -1;
        }

    case UDIV:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      x13 = XEXP (x3, 1);
      if (GET_CODE (x13) != REG)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (REGNO (x4))
        {
        case 24:
          switch (pattern281 (x1))
            {
            case 0:
              return 588; /* *udivmodqi4_call_split */

            case 1:
              return 3118; /* *udivsa3.call_split */

            case 2:
              return 3120; /* *udivusa3.call_split */

            default:
              return -1;
            }

        case 25:
          if (REGNO (x13) != 22
              || REGNO (x7) != 24)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != REG)
            return -1;
          switch (pattern342 (x1))
            {
            case 0:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3098; /* *udivqq3.call */

            case 1:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3100; /* *udivuqq3.call */

            default:
              return -1;
            }

        case 26:
          switch (pattern284 (x1))
            {
            case 0:
              return 3102; /* *udivhq3.call_split */

            case 1:
              return 3104; /* *udivuhq3.call_split */

            case 2:
              return 3106; /* *udivha3.call_split */

            case 3:
              return 3108; /* *udivuha3.call_split */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern111 (x1))
        {
        case 0:
          if (!
#line 4526 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 621; /* *andhi3 */

        case 1:
          if (!
#line 4560 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 623; /* *andpsi3 */

        case 2:
          if (!
#line 4595 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 625; /* *andsi3 */

        case 3:
          if (!
#line 11009 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1478; /* *nzb=1.and.zerox */

        case 4:
          if (!
#line 11129 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1493; /* *nzb=1.and.zerox.not */

        default:
          return -1;
        }

    case IOR:
      switch (pattern111 (x1))
        {
        case 0:
          if (!
#line 4674 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 629; /* *iorhi3 */

        case 1:
          if (!
#line 4706 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 631; /* *iorpsi3 */

        case 2:
          if (!
#line 4738 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 633; /* *iorsi3 */

        case 3:
          if (!
#line 11009 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1477; /* *nzb=1.ior.zerox */

        case 4:
          if (!
#line 11129 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1492; /* *nzb=1.ior.zerox.not */

        default:
          return -1;
        }

    case XOR:
      switch (pattern111 (x1))
        {
        case 0:
          if (!
#line 4795 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 637; /* *xorhi3 */

        case 1:
          if (!
#line 4825 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 639; /* *xorpsi3 */

        case 2:
          if (!
#line 4857 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 641; /* *xorsi3 */

        case 3:
          if (!
#line 11009 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1476; /* *nzb=1.xor.zerox */

        case 4:
          if (!
#line 11129 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          return 1491; /* *nzb=1.xor.zerox.not */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern105 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern113 (x3, 
E_HImode) != 0
              || !
#line 5611 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 692; /* *ashlhi3_const */

        case E_HQmode:
          if (pattern113 (x3, 
E_HQmode) != 0
              || !
#line 5611 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 693; /* *ashlhq3_const */

        case E_UHQmode:
          if (pattern113 (x3, 
E_UHQmode) != 0
              || !
#line 5611 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 694; /* *ashluhq3_const */

        case E_HAmode:
          if (pattern113 (x3, 
E_HAmode) != 0
              || !
#line 5611 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 695; /* *ashlha3_const */

        case E_UHAmode:
          if (pattern113 (x3, 
E_UHAmode) != 0
              || !
#line 5611 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 696; /* *ashluha3_const */

        case E_SImode:
          if (pattern114 (x3, 
E_SImode) != 0
              || !
#line 5709 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 697; /* *ashlsi3_const */

        case E_SQmode:
          if (pattern114 (x3, 
E_SQmode) != 0
              || !
#line 5709 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 698; /* *ashlsq3_const */

        case E_USQmode:
          if (pattern114 (x3, 
E_USQmode) != 0
              || !
#line 5709 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 699; /* *ashlusq3_const */

        case E_SAmode:
          if (pattern114 (x3, 
E_SAmode) != 0
              || !
#line 5709 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 700; /* *ashlsa3_const */

        case E_USAmode:
          if (pattern114 (x3, 
E_USAmode) != 0
              || !
#line 5709 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 701; /* *ashlusa3_const */

        case E_PSImode:
          if (pattern112 (x3) != 0
              || !
#line 5767 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 703; /* *ashlpsi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern115 (x1))
        {
        case 0:
          if (!
#line 5884 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 722; /* *ashrpsi3 */

        case 1:
          if (!
#line 5931 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 733; /* *ashrhi3_const */

        case 2:
          if (!
#line 5931 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 734; /* *ashrhq3_const */

        case 3:
          if (!
#line 5931 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 735; /* *ashruhq3_const */

        case 4:
          if (!
#line 5931 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 736; /* *ashrha3_const */

        case 5:
          if (!
#line 5931 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 737; /* *ashruha3_const */

        case 6:
          if (!
#line 5949 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 738; /* *ashrsi3_const */

        case 7:
          if (!
#line 5949 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 739; /* *ashrsq3_const */

        case 8:
          if (!
#line 5949 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 740; /* *ashrusq3_const */

        case 9:
          if (!
#line 5949 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 741; /* *ashrsa3_const */

        case 10:
          if (!
#line 5949 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 742; /* *ashrusa3_const */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern115 (x1))
        {
        case 0:
          if (!
#line 6084 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 760; /* *lshrpsi3 */

        case 1:
          if (!
#line 6187 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 771; /* *lshrhi3_const */

        case 2:
          if (!
#line 6187 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 772; /* *lshrhq3_const */

        case 3:
          if (!
#line 6187 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 773; /* *lshruhq3_const */

        case 4:
          if (!
#line 6187 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 774; /* *lshrha3_const */

        case 5:
          if (!
#line 6187 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 775; /* *lshruha3_const */

        case 6:
          if (!
#line 6204 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 776; /* *lshrsi3_const */

        case 7:
          if (!
#line 6204 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 777; /* *lshrsq3_const */

        case 8:
          if (!
#line 6204 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 778; /* *lshrusq3_const */

        case 9:
          if (!
#line 6204 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 779; /* *lshrsa3_const */

        case 10:
          if (!
#line 6204 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 780; /* *lshrusa3_const */

        default:
          return -1;
        }

    case COMPARE:
      return recog_81 (x1, insn, pnum_clobbers);

    case CLZ:
      if (pattern117 (x1) != 0
          || !
#line 9434 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1040; /* *clzhi2.libgcc */

    case CTZ:
      if (pattern117 (x1) != 0
          || !
#line 9503 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1044; /* *ctzhi2.libgcc */

    case FFS:
      if (pattern117 (x1) != 0
          || !
#line 9575 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1048; /* *ffshi2.libgcc */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x14 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x14) != REG)
        return -1;
      x15 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x15) != REG
          || GET_MODE (x15) != E_QImode)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (pattern116 (x5) != 0)
        return -1;
      switch (pattern299 (x1))
        {
        case 0:
          if (!
#line 9783 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1060; /* *fmul.call */

        case 1:
          if (!
#line 9855 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1064; /* *fmuls.call */

        case 2:
          if (!
#line 9927 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1068; /* *fmulsu.call */

        case 3:
          if (!
#line 729 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3148; /* *roundqq3.libgcc */

        case 4:
          if (!
#line 729 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3149; /* *rounduqq3.libgcc */

        case 5:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3154; /* *roundhq3.libgcc */

        case 6:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3155; /* *rounduhq3.libgcc */

        case 7:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3156; /* *roundha3.libgcc */

        case 8:
          if (!
#line 755 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3157; /* *rounduha3.libgcc */

        case 9:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3162; /* *roundsq3.libgcc */

        case 10:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3163; /* *roundusq3.libgcc */

        case 11:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3164; /* *roundsa3.libgcc */

        case 12:
          if (!
#line 781 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3165; /* *roundusa3.libgcc */

        default:
          return -1;
        }

    case DIV:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      x13 = XEXP (x3, 1);
      if (GET_CODE (x13) != REG)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || pattern106 (x1) != 0)
        return -1;
      switch (REGNO (x4))
        {
        case 25:
          if (REGNO (x13) != 22
              || REGNO (x7) != 24)
            return -1;
          switch (pattern342 (x1))
            {
            case 0:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3099; /* *divqq3.call */

            case 1:
              if (!
#line 529 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3101; /* *divuqq3.call */

            default:
              return -1;
            }

        case 26:
          switch (pattern312 (x1, 
E_QImode, 
21, 
26, 
22))
            {
            case 0:
              return 3103; /* *divhq3.call_split */

            case 1:
              return 3105; /* *divuhq3.call_split */

            case 2:
              return 3107; /* *divha3.call_split */

            case 3:
              return 3109; /* *divuha3.call_split */

            default:
              return -1;
            }

        case 24:
          if (REGNO (x13) != 18
              || REGNO (x7) != 22)
            return -1;
          switch (pattern280 (x1))
            {
            case 0:
              return 3119; /* *divsa3.call_split */

            case 1:
              return 3121; /* *divusa3.call_split */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case ZERO_EXTRACT:
      if (GET_MODE (x2) == E_QImode)
        {
          x3 = XEXP (x2, 1);
          if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              if (register_operand (operands[0], E_QImode))
                {
                  x5 = XEXP (x2, 2);
                  operands[1] = x5;
                  if (const_0_to_7_operand (operands[1], E_QImode))
                    {
                      x6 = XEXP (x1, 1);
                      operands[2] = x6;
                      if (nonmemory_operand (operands[2], E_QImode)
                          && 
#line 10039 "../../gcc/config/avr/avr.md"
( reload_completed))
                        return gen_split_671 (insn, operands);
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  x6 = XEXP (x1, 1);
  if (GET_CODE (x6) != SUBREG)
    return NULL;
  operands[0] = x2;
  switch (SUBREG_BYTE (x6))
    {
    case 0:
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x6) != E_HImode
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 5301 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 2 > 1))
                return NULL;
              return gen_split_414 (insn, operands);

            case E_PSImode:
              if (!register_operand (operands[0], E_PSImode)
                  || GET_MODE (x6) != E_PSImode)
                return NULL;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (!nonimmediate_operand (operands[1], E_QImode)
                      || !
#line 5301 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 3 > 1))
                    return NULL;
                  return gen_split_415 (insn, operands);

                case E_HImode:
                  if (!nonimmediate_operand (operands[1], E_HImode)
                      || !
#line 5301 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 3 > 2))
                    return NULL;
                  return gen_split_417 (insn, operands);

                default:
                  return NULL;
                }

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x6) != E_SImode)
                return NULL;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (!nonimmediate_operand (operands[1], E_QImode)
                      || !
#line 5301 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 4 > 1))
                    return NULL;
                  return gen_split_416 (insn, operands);

                case E_HImode:
                  if (!nonimmediate_operand (operands[1], E_HImode)
                      || !
#line 5301 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 4 > 2))
                    return NULL;
                  return gen_split_418 (insn, operands);

                case E_PSImode:
                  if (!nonimmediate_operand (operands[1], E_PSImode)
                      || !
#line 5301 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 4 > 3))
                    return NULL;
                  return gen_split_419 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case ASHIFT:
          if (GET_MODE (x7) != E_HImode
              || GET_MODE (x6) != E_QImode)
            return NULL;
          switch (pattern216 (x7))
            {
            case 0:
              if (register_operand (operands[0], E_QImode))
                return gen_split_437 (insn, operands);
              if (!memory_operand (operands[0], E_QImode)
                  || !(
#line 5444 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 5446 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_439 (insn, operands);

            case 1:
              if (register_operand (operands[0], E_QImode))
                return gen_split_438 (insn, operands);
              if (!memory_operand (operands[0], E_QImode)
                  || !(
#line 5444 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 5446 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_440 (insn, operands);

            case 2:
              if (!(
#line 5462 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 5464 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_441 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          if (pattern178 (x7) != 0
              || !register_operand (operands[0], E_QImode)
              || GET_MODE (x6) != E_QImode)
            return NULL;
          x8 = XEXP (x7, 1);
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_QImode)
              || !
#line 9037 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_642 (insn, operands);

        case ZERO_EXTRACT:
          x8 = XEXP (x7, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_QImode)
              || GET_MODE (x6) != E_QImode)
            return NULL;
          switch (pattern233 (x7))
            {
            case 0:
              if (!(
#line 10505 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10507 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_739 (insn, operands);

            case 1:
              if (!(
#line 10505 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10507 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_740 (insn, operands);

            case 2:
              if (!(
#line 10505 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10507 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_741 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      if (GET_MODE (x6) != E_QImode)
        return NULL;
      x7 = XEXP (x6, 0);
      if (pattern159 (x7) != 0)
        return NULL;
      return gen_split_646 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (pattern151 (x3) == 0
          && 
#line 4486 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_367 (insn, operands);
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_QImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      switch (pattern220 (x3))
        {
        case 0:
          if (!(
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10673 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_780 (insn, operands);

        case 1:
          if (!(
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10673 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_782 (insn, operands);

        case 2:
          if (!(
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10673 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_784 (insn, operands);

        case 3:
          if (!(
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10673 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_781 (insn, operands);

        case 4:
          if (!(
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10673 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_783 (insn, operands);

        case 5:
          if (!(
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10673 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_785 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern76 (x3))
        {
        case 0:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_764 (insn, operands);

        case 1:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_767 (insn, operands);

        case 2:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_770 (insn, operands);

        case 3:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_773 (insn, operands);

        case 4:
          if (!
#line 11031 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1032 (insn, operands);

        case 5:
          if (!
#line 11082 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1038 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern77 (x3))
        {
        case 0:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_765 (insn, operands);

        case 1:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_768 (insn, operands);

        case 2:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_771 (insn, operands);

        case 3:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_774 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern77 (x3))
        {
        case 0:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_766 (insn, operands);

        case 1:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_769 (insn, operands);

        case 2:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_772 (insn, operands);

        case 3:
          if (!
#line 10621 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_775 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      switch (pattern135 (x3))
        {
        case 0:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1011 (insn, operands);

        case 1:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1015 (insn, operands);

        case 2:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1019 (insn, operands);

        case 3:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1023 (insn, operands);

        case 4:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1012 (insn, operands);

        case 5:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1016 (insn, operands);

        case 6:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1020 (insn, operands);

        case 7:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1024 (insn, operands);

        case 8:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1013 (insn, operands);

        case 9:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1017 (insn, operands);

        case 10:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1021 (insn, operands);

        case 11:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1025 (insn, operands);

        case 12:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1014 (insn, operands);

        case 13:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1018 (insn, operands);

        case 14:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1022 (insn, operands);

        case 15:
          if (!(
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10956 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1026 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern120 (x3))
        {
        case 0:
          if (!
#line 10987 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1029 (insn, operands);

        case 1:
          if (!
#line 11057 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1035 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      if (pattern121 (x3) != 0
          || !
#line 11106 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
        return NULL;
      return gen_split_1041 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern39 (x1))
        {
        case 0:
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || !
#line 3074 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_303 (insn, operands);

        case 1:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_999 (insn, operands);

        case 2:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1001 (insn, operands);

        case 3:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1005 (insn, operands);

        case 4:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1003 (insn, operands);

        case 5:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1007 (insn, operands);

        case 6:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1009 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (GET_CODE (x3))
        {
        case SUBREG:
          res = split_6 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case REG:
          res = split_7 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (pattern152 (x2))
        {
        case 0:
          if (!
#line 5365 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_429 (insn, operands);

        case 1:
          if (!
#line 5365 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_430 (insn, operands);

        case 2:
          if (!
#line 5365 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_431 (insn, operands);

        case 3:
          if (!
#line 5392 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_432 (insn, operands);

        case 4:
          if (!
#line 5392 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_433 (insn, operands);

        case 5:
          if (!
#line 5392 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_434 (insn, operands);

        case 6:
          if (!
#line 5392 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_435 (insn, operands);

        case 7:
          if (!
#line 5392 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_436 (insn, operands);

        case 8:
          if (!
#line 5508 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_442 (insn, operands);

        case 9:
          if (!
#line 5508 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_443 (insn, operands);

        case 10:
          if (!
#line 5508 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_444 (insn, operands);

        case 11:
          if (!
#line 5508 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_445 (insn, operands);

        case 12:
          if (!
#line 5508 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_446 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1LL
          || pattern73 (x1) != 0
          || !
#line 9004 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_641 (insn, operands);

    case ZERO_EXTEND:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != AND)
        return NULL;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern38 (x2))
        {
        case 0:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1000 (insn, operands);

        case 1:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1002 (insn, operands);

        case 2:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1006 (insn, operands);

        case 3:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1004 (insn, operands);

        case 4:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1008 (insn, operands);

        case 5:
          if (!(
#line 10926 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10930 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1010 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_26 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  switch (pattern231 (x5))
    {
    case 0:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_17 (insn, operands);

    case 1:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_18 (insn, operands);

    case 2:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_19 (insn, operands);

    case 3:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_20 (insn, operands);

    case 4:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_21 (insn, operands);

    case 5:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_22 (insn, operands);

    case 6:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_23 (insn, operands);

    case 7:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_24 (insn, operands);

    case 8:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_25 (insn, operands);

    case 9:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_26 (insn, operands);

    case 10:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_27 (insn, operands);

    case 11:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_28 (insn, operands);

    case 12:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_29 (insn, operands);

    case 13:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_30 (insn, operands);

    case 14:
      if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_31 (insn, operands);

    case 15:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !general_operand (operands[1], E_QImode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_70 (insn, operands);

        case E_QQmode:
          if (!nonimmediate_operand (operands[0], E_QQmode)
              || !general_operand (operands[1], E_QQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_71 (insn, operands);

        case E_UQQmode:
          if (!nonimmediate_operand (operands[0], E_UQQmode)
              || !general_operand (operands[1], E_UQQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_72 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !general_operand (operands[1], E_HImode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_73 (insn, operands);

        case E_HQmode:
          if (!nonimmediate_operand (operands[0], E_HQmode)
              || !general_operand (operands[1], E_HQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_74 (insn, operands);

        case E_UHQmode:
          if (!nonimmediate_operand (operands[0], E_UHQmode)
              || !general_operand (operands[1], E_UHQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_75 (insn, operands);

        case E_HAmode:
          if (!nonimmediate_operand (operands[0], E_HAmode)
              || !general_operand (operands[1], E_HAmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_76 (insn, operands);

        case E_UHAmode:
          if (!nonimmediate_operand (operands[0], E_UHAmode)
              || !general_operand (operands[1], E_UHAmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_77 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !general_operand (operands[1], E_SImode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_78 (insn, operands);

        case E_SQmode:
          if (!nonimmediate_operand (operands[0], E_SQmode)
              || !general_operand (operands[1], E_SQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_79 (insn, operands);

        case E_USQmode:
          if (!nonimmediate_operand (operands[0], E_USQmode)
              || !general_operand (operands[1], E_USQmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_80 (insn, operands);

        case E_SAmode:
          if (!nonimmediate_operand (operands[0], E_SAmode)
              || !general_operand (operands[1], E_SAmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_81 (insn, operands);

        case E_USAmode:
          if (!nonimmediate_operand (operands[0], E_USAmode)
              || !general_operand (operands[1], E_USAmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_82 (insn, operands);

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || !general_operand (operands[1], E_SFmode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_83 (insn, operands);

        case E_PSImode:
          if (!nonimmediate_operand (operands[0], E_PSImode)
              || !general_operand (operands[1], E_PSImode)
              || !
#line 1077 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_84 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (pattern326 (x4) != 0)
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (pattern388 (x5) != 0)
    return NULL;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_PSImode)
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      switch (pattern395 (x9, 
E_PSImode))
        {
        case 0:
          if (!
#line 7449 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_200 (insn, operands);

        case 1:
          if (!
#line 7449 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_201 (insn, operands);

        case 2:
          if (!
#line 7449 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_202 (insn, operands);

        case 3:
          if (!
#line 7449 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_203 (insn, operands);

        case 4:
          if (!
#line 7449 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_204 (insn, operands);

        case 5:
          if (!
#line 7449 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_205 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern397 (x3))
        {
        case 0:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_206 (insn, operands);

        case 1:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_207 (insn, operands);

        case 2:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_208 (insn, operands);

        case 3:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_209 (insn, operands);

        case 4:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_210 (insn, operands);

        case 5:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_211 (insn, operands);

        case 6:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_218 (insn, operands);

        case 7:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_219 (insn, operands);

        case 8:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_220 (insn, operands);

        case 9:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_221 (insn, operands);

        case 10:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_222 (insn, operands);

        case 11:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_223 (insn, operands);

        case 12:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_242 (insn, operands);

        case 13:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_243 (insn, operands);

        case 14:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_244 (insn, operands);

        case 15:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_245 (insn, operands);

        case 16:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_246 (insn, operands);

        case 17:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_247 (insn, operands);

        case 18:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_230 (insn, operands);

        case 19:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_231 (insn, operands);

        case 20:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_232 (insn, operands);

        case 21:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_233 (insn, operands);

        case 22:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_234 (insn, operands);

        case 23:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_235 (insn, operands);

        case 24:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_254 (insn, operands);

        case 25:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_255 (insn, operands);

        case 26:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_256 (insn, operands);

        case 27:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_257 (insn, operands);

        case 28:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_258 (insn, operands);

        case 29:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_259 (insn, operands);

        case 30:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_266 (insn, operands);

        case 31:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_267 (insn, operands);

        case 32:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_268 (insn, operands);

        case 33:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_269 (insn, operands);

        case 34:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_270 (insn, operands);

        case 35:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_271 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern397 (x3))
        {
        case 0:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_212 (insn, operands);

        case 1:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_213 (insn, operands);

        case 2:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_214 (insn, operands);

        case 3:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_215 (insn, operands);

        case 4:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_216 (insn, operands);

        case 5:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_217 (insn, operands);

        case 6:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_224 (insn, operands);

        case 7:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_225 (insn, operands);

        case 8:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_226 (insn, operands);

        case 9:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_227 (insn, operands);

        case 10:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_228 (insn, operands);

        case 11:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_229 (insn, operands);

        case 12:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_248 (insn, operands);

        case 13:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_249 (insn, operands);

        case 14:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_250 (insn, operands);

        case 15:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_251 (insn, operands);

        case 16:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_252 (insn, operands);

        case 17:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_253 (insn, operands);

        case 18:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_236 (insn, operands);

        case 19:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_237 (insn, operands);

        case 20:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_238 (insn, operands);

        case 21:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_239 (insn, operands);

        case 22:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_240 (insn, operands);

        case 23:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_241 (insn, operands);

        case 24:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_260 (insn, operands);

        case 25:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_261 (insn, operands);

        case 26:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_262 (insn, operands);

        case 27:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_263 (insn, operands);

        case 28:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_264 (insn, operands);

        case 29:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_265 (insn, operands);

        case 30:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_272 (insn, operands);

        case 31:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_273 (insn, operands);

        case 32:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_274 (insn, operands);

        case 33:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_275 (insn, operands);

        case 34:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_276 (insn, operands);

        case 35:
          if (!
#line 7480 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_277 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
