/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x3) != E_QQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 0;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 1;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 2;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 3;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 4;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 5;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 6;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 7;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 8;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 9;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 10;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 11;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 12;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 13;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 14;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 15;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 16;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 17;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x3) != E_UQQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 19;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 20;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 21;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 22;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 23;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 24;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 25;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 26;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 27;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 28;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 29;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 30;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 31;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 32;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 33;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 34;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 35;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 36;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 38;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 39;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 40;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 41;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 42;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 43;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 44;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 45;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 46;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 47;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 48;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 49;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 50;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 51;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 52;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 53;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 54;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 55;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 57;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 58;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 59;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 60;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 61;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 62;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 63;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 64;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 65;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 66;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 67;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 68;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 69;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 70;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 71;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 72;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 73;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 74;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 75;

        default:
          return -1;
        }

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 76;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 77;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 78;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 79;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 80;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 81;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 82;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 83;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 84;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 85;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 86;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 87;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 88;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 89;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 90;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 91;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 92;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 93;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 95;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 96;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 97;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 98;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 99;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 100;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 101;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 102;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 103;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 104;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 105;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 106;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 107;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 108;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 109;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 110;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 111;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 112;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x3) != E_SQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 114;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 115;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 116;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 117;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 118;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 119;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 120;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 121;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 122;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 123;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 124;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 125;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 126;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 127;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 128;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 129;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 130;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 131;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 132;

        default:
          return -1;
        }

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x3) != E_USQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 133;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 134;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 135;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 136;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 137;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 138;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 139;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 140;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 141;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 142;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 143;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 144;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 145;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 146;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 147;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 148;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 149;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 150;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 151;

        default:
          return -1;
        }

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x3) != E_SAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 152;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 153;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 154;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 155;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 156;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 157;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 158;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 159;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 160;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 161;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 162;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 163;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 164;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 165;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 166;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 167;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 168;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 169;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 170;

        default:
          return -1;
        }

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x3) != E_USAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 171;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 172;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 173;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 174;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 175;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 176;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 177;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 178;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 179;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 180;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 181;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 182;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 183;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 184;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 185;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 186;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 187;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 188;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 189;

        default:
          return -1;
        }

    case E_DQmode:
      if (!register_operand (operands[0], E_DQmode)
          || GET_MODE (x3) != E_DQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 190;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 191;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 192;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 193;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 194;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 195;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 196;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 197;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 198;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 199;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 200;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 201;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 202;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 203;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 204;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 205;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 206;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 207;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 208;

        default:
          return -1;
        }

    case E_UDQmode:
      if (!register_operand (operands[0], E_UDQmode)
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 209;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 210;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 211;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 212;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 213;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 214;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 215;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 216;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 217;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 218;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 219;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 220;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 221;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 222;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 223;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 224;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 225;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 226;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 227;

        default:
          return -1;
        }

    case E_DAmode:
      if (!register_operand (operands[0], E_DAmode)
          || GET_MODE (x3) != E_DAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 228;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 229;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 230;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 231;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 232;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 233;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 234;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 235;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 236;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 237;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 238;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 239;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 240;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 241;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 242;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 243;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 244;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 245;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 246;

        default:
          return -1;
        }

    case E_UDAmode:
      if (!register_operand (operands[0], E_UDAmode)
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 247;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 248;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 249;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 250;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 251;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 252;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 253;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 254;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 255;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 256;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 257;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 258;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 259;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 260;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 261;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 262;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 263;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 264;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 265;

        default:
          return -1;
        }

    case E_TAmode:
      if (!register_operand (operands[0], E_TAmode)
          || GET_MODE (x3) != E_TAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 266;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 267;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 268;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 269;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 270;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 271;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 272;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 273;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 274;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 275;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 276;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 277;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 278;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 279;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 280;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 281;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 282;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 283;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 284;

        default:
          return -1;
        }

    case E_UTAmode:
      if (!register_operand (operands[0], E_UTAmode)
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 285;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 286;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 287;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 288;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 289;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 290;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 291;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 292;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 293;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 294;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 295;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 296;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 297;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 298;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 299;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 300;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 301;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 302;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 303;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 304;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 305;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 306;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 307;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 308;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 309;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 310;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 311;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 312;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 313;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 314;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 315;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 316;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 317;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 318;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 319;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 320;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 321;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 322;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 323;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 324;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 325;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 326;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 327;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 328;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 329;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 330;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 331;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 332;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 333;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 334;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 335;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 336;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 337;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 338;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 339;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 340;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 341;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 342;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 343;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 344;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 345;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 346;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 347;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 348;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 349;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 350;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 351;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 352;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 353;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 354;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 355;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 356;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 357;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 358;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 359;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 360;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 361;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 362;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 363;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 364;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 365;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 366;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 367;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 368;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 369;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 370;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 371;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 372;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 373;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 374;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 375;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 376;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 377;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 378;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 379;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern21 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (register_operand (operands[1], E_QImode)
          && const0_operand (operands[0], E_QImode)
          && 
#line 6772 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 828; /* *swapped_tstqi */
      if (register_operand (operands[1], E_QQmode)
          && const0_operand (operands[0], E_QQmode)
          && 
#line 6772 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 829; /* *swapped_tstqq */
      if (register_operand (operands[1], E_HImode)
          && const0_operand (operands[0], E_HImode)
          && 
#line 6782 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 830; /* *swapped_tsthi */
      if (register_operand (operands[1], E_HQmode)
          && const0_operand (operands[0], E_HQmode)
          && 
#line 6782 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 831; /* *swapped_tsthq */
      if (register_operand (operands[1], E_HAmode)
          && const0_operand (operands[0], E_HAmode)
          && 
#line 6782 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 832; /* *swapped_tstha */
      if (register_operand (operands[1], E_SImode)
          && const0_operand (operands[0], E_SImode)
          && 
#line 6802 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 834; /* *swapped_tstsi */
      if (register_operand (operands[1], E_SQmode)
          && const0_operand (operands[0], E_SQmode)
          && 
#line 6802 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 835; /* *swapped_tstsq */
      if (register_operand (operands[1], E_SAmode)
          && const0_operand (operands[0], E_SAmode)
          && 
#line 6802 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 836; /* *swapped_tstsa */
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x4;
      if (!register_operand (operands[0], E_PSImode)
          || !
#line 6792 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 833; /* *swapped_tstpsi */

    case REG:
    case SUBREG:
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (register_operand (operands[0], E_QImode)
                  && nonmemory_operand (operands[1], E_QImode)
                  && 
#line 6816 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 837; /* cmpqi3 */
              break;

            case E_QQmode:
              if (register_operand (operands[0], E_QQmode)
                  && nonmemory_operand (operands[1], E_QQmode)
                  && 
#line 6816 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 838; /* cmpqq3 */
              break;

            case E_UQQmode:
              if (register_operand (operands[0], E_UQQmode)
                  && nonmemory_operand (operands[1], E_UQQmode)
                  && 
#line 6816 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 839; /* cmpuqq3 */
              break;

            case E_HImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_HImode)
                  && nonmemory_operand (operands[1], E_HImode)
                  && 
#line 6858 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 864; /* cmphi3 */
                }
              break;

            case E_HQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_HQmode)
                  && nonmemory_operand (operands[1], E_HQmode)
                  && 
#line 6858 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 865; /* cmphq3 */
                }
              break;

            case E_UHQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_UHQmode)
                  && nonmemory_operand (operands[1], E_UHQmode)
                  && 
#line 6858 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 866; /* cmpuhq3 */
                }
              break;

            case E_HAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_HAmode)
                  && nonmemory_operand (operands[1], E_HAmode)
                  && 
#line 6858 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 867; /* cmpha3 */
                }
              break;

            case E_UHAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_UHAmode)
                  && nonmemory_operand (operands[1], E_UHAmode)
                  && 
#line 6858 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 868; /* cmpuha3 */
                }
              break;

            case E_PSImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_PSImode)
                  && nonmemory_operand (operands[1], E_PSImode)
                  && 
#line 6893 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 869; /* *cmppsi */
                }
              break;

            case E_SImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_SImode)
                  && nonmemory_operand (operands[1], E_SImode)
                  && 
#line 6925 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 870; /* *cmpsi */
                }
              break;

            case E_SQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_SQmode)
                  && nonmemory_operand (operands[1], E_SQmode)
                  && 
#line 6925 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 871; /* *cmpsq */
                }
              break;

            case E_USQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_USQmode)
                  && nonmemory_operand (operands[1], E_USQmode)
                  && 
#line 6925 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 872; /* *cmpusq */
                }
              break;

            case E_SAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_SAmode)
                  && nonmemory_operand (operands[1], E_SAmode)
                  && 
#line 6925 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 873; /* *cmpsa */
                }
              break;

            case E_USAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_USAmode)
                  && nonmemory_operand (operands[1], E_USAmode)
                  && 
#line 6925 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 874; /* *cmpusa */
                }
              break;

            default:
              break;
            }
          break;

        case SIGN_EXTEND:
          switch (pattern235 (x4))
            {
            case 0:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return 852; /* *cmphi.sign_extendqi.1 */
              break;

            case 1:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return 854; /* *cmppsi.sign_extendqi.1 */
              break;

            case 2:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return 858; /* *cmppsi.sign_extendhi.1 */
              break;

            case 3:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return 856; /* *cmpsi.sign_extendqi.1 */
              break;

            case 4:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return 860; /* *cmpsi.sign_extendhi.1 */
              break;

            case 5:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return 862; /* *cmpsi.sign_extendpsi.1 */
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          switch (pattern235 (x4))
            {
            case 0:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return 853; /* *cmphi.zero_extendqi.1 */
              break;

            case 1:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return 855; /* *cmppsi.zero_extendqi.1 */
              break;

            case 2:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return 859; /* *cmppsi.zero_extendhi.1 */
              break;

            case 3:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return 857; /* *cmpsi.zero_extendqi.1 */
              break;

            case 4:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return 861; /* *cmpsi.zero_extendhi.1 */
              break;

            case 5:
              if (
#line 6842 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return 863; /* *cmpsi.zero_extendpsi.1 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 18)
        return -1;
      switch (GET_CODE (x4))
        {
        case REG:
          if (REGNO (x4) != 10)
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (GET_MODE (x4) != E_DImode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3281; /* compare_di2 */

            case E_DQmode:
              if (GET_MODE (x4) != E_DQmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3282; /* compare_dq2 */

            case E_UDQmode:
              if (GET_MODE (x4) != E_UDQmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3283; /* compare_udq2 */

            case E_DAmode:
              if (GET_MODE (x4) != E_DAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3284; /* compare_da2 */

            case E_UDAmode:
              if (GET_MODE (x4) != E_UDAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3285; /* compare_uda2 */

            case E_TAmode:
              if (GET_MODE (x4) != E_TAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3286; /* compare_ta2 */

            case E_UTAmode:
              if (GET_MODE (x4) != E_UTAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3287; /* compare_uta2 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern255 (x4, 
E_QImode, 
E_DImode) != 0
              || GET_MODE (x3) != E_DImode
              || !
#line 543 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
            return -1;
          return 3289; /* compare_const8_di2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern205 (x2))
        {
        case 0:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 840; /* *cmphi.sign_extendqi.0 */

        case 1:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 842; /* *cmppsi.sign_extendqi.0 */

        case 2:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 846; /* *cmppsi.sign_extendhi.0 */

        case 3:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 844; /* *cmpsi.sign_extendqi.0 */

        case 4:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 848; /* *cmpsi.sign_extendhi.0 */

        case 5:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 850; /* *cmpsi.sign_extendpsi.0 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern205 (x2))
        {
        case 0:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 841; /* *cmphi.zero_extendqi.0 */

        case 1:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 843; /* *cmppsi.zero_extendqi.0 */

        case 2:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 847; /* *cmppsi.zero_extendhi.0 */

        case 3:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 845; /* *cmpsi.zero_extendqi.0 */

        case 4:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 849; /* *cmpsi.zero_extendhi.0 */

        case 5:
          if (!
#line 6829 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 851; /* *cmpsi.zero_extendpsi.0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern17 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern88 (x1))
        {
        case 0:
          return 785; /* negqi2 */

        case 1:
          return 789; /* neghi2 */

        case 2:
          return 791; /* negpsi2 */

        case 3:
          return 793; /* negsi2 */

        case 4:
          return 796; /* negsf2 */

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case REG:
          res = recog_19 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case SUBREG:
          switch (pattern89 (x1))
            {
            case 0:
              if (
#line 10586 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1177; /* *neg.ashiftrtqi.msb */
              break;

            case 1:
              if (
#line 10586 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1178; /* *neg.ashiftrthi.msb */
              break;

            case 2:
              if (
#line 10586 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1179; /* *neg.ashiftrtpsi.msb */
              break;

            case 3:
              if (
#line 10586 "../../gcc/config/avr/avr.md"
(! reload_completed))
                return 1180; /* *neg.ashiftrtsi.msb */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !
#line 6359 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 795; /* *negsi2 */

    case 1:
      return 787; /* *negqihi2_split */

    case 2:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1248; /* *neg.zextr-to-sextr.hi.qi */

    case 3:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1249; /* *neg.zextr-to-sextr.hi.hi */

    case 4:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1250; /* *neg.zextr-to-sextr.hi.psi */

    case 5:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1251; /* *neg.zextr-to-sextr.hi.si */

    case 6:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1252; /* *neg.zextr-to-sextr.psi.qi */

    case 7:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1253; /* *neg.zextr-to-sextr.psi.hi */

    case 8:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1254; /* *neg.zextr-to-sextr.psi.psi */

    case 9:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1255; /* *neg.zextr-to-sextr.psi.si */

    case 10:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1260; /* *neg.zextr-to-sextr.psi.qi */

    case 11:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1261; /* *neg.zextr-to-sextr.psi.hi */

    case 12:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1262; /* *neg.zextr-to-sextr.psi.psi */

    case 13:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1263; /* *neg.zextr-to-sextr.psi.si */

    case 14:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1256; /* *neg.zextr-to-sextr.si.qi */

    case 15:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1257; /* *neg.zextr-to-sextr.si.hi */

    case 16:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1258; /* *neg.zextr-to-sextr.si.psi */

    case 17:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1259; /* *neg.zextr-to-sextr.si.si */

    case 18:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1264; /* *neg.zextr-to-sextr.si.qi */

    case 19:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1265; /* *neg.zextr-to-sextr.si.hi */

    case 20:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1266; /* *neg.zextr-to-sextr.si.psi */

    case 21:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1267; /* *neg.zextr-to-sextr.si.si */

    case 22:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1268; /* *neg.zextr-to-sextr.si.qi */

    case 23:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1269; /* *neg.zextr-to-sextr.si.hi */

    case 24:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1270; /* *neg.zextr-to-sextr.si.psi */

    case 25:
      if (!
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1271; /* *neg.zextr-to-sextr.si.si */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern241 (x1))
        {
        case 0:
          if (
#line 5376 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 664; /* *ashlqi3 */
          break;

        case 1:
          if (
#line 5376 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 665; /* *ashlqq3 */
          break;

        case 2:
          if (
#line 5376 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 666; /* *ashluqq3 */
          break;

        case 3:
          if (
#line 5408 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 672; /* *ashlhi3 */
          break;

        case 4:
          if (
#line 5408 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 673; /* *ashlhq3 */
          break;

        case 5:
          if (
#line 5408 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 674; /* *ashluhq3 */
          break;

        case 6:
          if (
#line 5408 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 675; /* *ashlha3 */
          break;

        case 7:
          if (
#line 5408 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 676; /* *ashluha3 */
          break;

        case 8:
          if (
#line 5521 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 687; /* *ashlsi3 */
          break;

        case 9:
          if (
#line 5521 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 688; /* *ashlsq3 */
          break;

        case 10:
          if (
#line 5521 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 689; /* *ashlusq3 */
          break;

        case 11:
          if (
#line 5521 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 690; /* *ashlsa3 */
          break;

        case 12:
          if (
#line 5521 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 691; /* *ashlusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SImode) != 0
          || !
#line 5709 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 697; /* *ashlsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SQmode) != 0
          || !
#line 5709 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 698; /* *ashlsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_USQmode) != 0
          || !
#line 5709 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 699; /* *ashlusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SAmode) != 0
          || !
#line 5709 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 700; /* *ashlsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_USAmode) != 0
          || !
#line 5709 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 701; /* *ashlusa3_const */

    case E_PSImode:
      if (pattern112 (x4) != 0)
        return -1;
      return 702; /* *ashlpsi3_split */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode
   && reload_completed))
        return -1;
      return 2636; /* *fractunsuqqqq2 */

    case 1:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QQmode
   && reload_completed))
        return -1;
      return 2637; /* *fractunshqqq2 */

    case 2:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode
   && reload_completed))
        return -1;
      return 2638; /* *fractunsuhqqq2 */

    case 3:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QQmode
   && reload_completed))
        return -1;
      return 2639; /* *fractunshaqq2 */

    case 4:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode
   && reload_completed))
        return -1;
      return 2640; /* *fractunsuhaqq2 */

    case 5:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QQmode
   && reload_completed))
        return -1;
      return 2641; /* *fractunssqqq2 */

    case 6:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QQmode
   && reload_completed))
        return -1;
      return 2642; /* *fractunsusqqq2 */

    case 7:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QQmode
   && reload_completed))
        return -1;
      return 2643; /* *fractunssaqq2 */

    case 8:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QQmode
   && reload_completed))
        return -1;
      return 2644; /* *fractunsusaqq2 */

    case 9:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QQmode
   && reload_completed))
        return -1;
      return 2645; /* *fractunsdqqq2 */

    case 10:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode
   && reload_completed))
        return -1;
      return 2646; /* *fractunsudqqq2 */

    case 11:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QQmode
   && reload_completed))
        return -1;
      return 2647; /* *fractunsdaqq2 */

    case 12:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode
   && reload_completed))
        return -1;
      return 2648; /* *fractunsudaqq2 */

    case 13:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QQmode
   && reload_completed))
        return -1;
      return 2649; /* *fractunstaqq2 */

    case 14:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode
   && reload_completed))
        return -1;
      return 2650; /* *fractunsutaqq2 */

    case 15:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != QQmode
   && reload_completed))
        return -1;
      return 2651; /* *fractunsqiqq2 */

    case 16:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != QQmode
   && reload_completed))
        return -1;
      return 2652; /* *fractunshiqq2 */

    case 17:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != QQmode
   && reload_completed))
        return -1;
      return 2653; /* *fractunssiqq2 */

    case 18:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != QQmode
   && reload_completed))
        return -1;
      return 2654; /* *fractunsdiqq2 */

    case 19:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode
   && reload_completed))
        return -1;
      return 2655; /* *fractunsqquqq2 */

    case 20:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode
   && reload_completed))
        return -1;
      return 2656; /* *fractunshquqq2 */

    case 21:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode
   && reload_completed))
        return -1;
      return 2657; /* *fractunsuhquqq2 */

    case 22:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode
   && reload_completed))
        return -1;
      return 2658; /* *fractunshauqq2 */

    case 23:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode
   && reload_completed))
        return -1;
      return 2659; /* *fractunsuhauqq2 */

    case 24:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode
   && reload_completed))
        return -1;
      return 2660; /* *fractunssquqq2 */

    case 25:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode
   && reload_completed))
        return -1;
      return 2661; /* *fractunsusquqq2 */

    case 26:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode
   && reload_completed))
        return -1;
      return 2662; /* *fractunssauqq2 */

    case 27:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode
   && reload_completed))
        return -1;
      return 2663; /* *fractunsusauqq2 */

    case 28:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode
   && reload_completed))
        return -1;
      return 2664; /* *fractunsdquqq2 */

    case 29:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode
   && reload_completed))
        return -1;
      return 2665; /* *fractunsudquqq2 */

    case 30:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode
   && reload_completed))
        return -1;
      return 2666; /* *fractunsdauqq2 */

    case 31:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode
   && reload_completed))
        return -1;
      return 2667; /* *fractunsudauqq2 */

    case 32:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode
   && reload_completed))
        return -1;
      return 2668; /* *fractunstauqq2 */

    case 33:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode
   && reload_completed))
        return -1;
      return 2669; /* *fractunsutauqq2 */

    case 34:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UQQmode
   && reload_completed))
        return -1;
      return 2670; /* *fractunsqiuqq2 */

    case 35:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UQQmode
   && reload_completed))
        return -1;
      return 2671; /* *fractunshiuqq2 */

    case 36:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UQQmode
   && reload_completed))
        return -1;
      return 2672; /* *fractunssiuqq2 */

    case 37:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UQQmode
   && reload_completed))
        return -1;
      return 2673; /* *fractunsdiuqq2 */

    case 38:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HQmode
   && reload_completed))
        return -1;
      return 2674; /* *fractunsqqhq2 */

    case 39:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode
   && reload_completed))
        return -1;
      return 2675; /* *fractunsuqqhq2 */

    case 40:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode
   && reload_completed))
        return -1;
      return 2676; /* *fractunsuhqhq2 */

    case 41:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HQmode
   && reload_completed))
        return -1;
      return 2677; /* *fractunshahq2 */

    case 42:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode
   && reload_completed))
        return -1;
      return 2678; /* *fractunsuhahq2 */

    case 43:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HQmode
   && reload_completed))
        return -1;
      return 2679; /* *fractunssqhq2 */

    case 44:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HQmode
   && reload_completed))
        return -1;
      return 2680; /* *fractunsusqhq2 */

    case 45:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HQmode
   && reload_completed))
        return -1;
      return 2681; /* *fractunssahq2 */

    case 46:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HQmode
   && reload_completed))
        return -1;
      return 2682; /* *fractunsusahq2 */

    case 47:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HQmode
   && reload_completed))
        return -1;
      return 2683; /* *fractunsdqhq2 */

    case 48:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode
   && reload_completed))
        return -1;
      return 2684; /* *fractunsudqhq2 */

    case 49:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HQmode
   && reload_completed))
        return -1;
      return 2685; /* *fractunsdahq2 */

    case 50:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode
   && reload_completed))
        return -1;
      return 2686; /* *fractunsudahq2 */

    case 51:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HQmode
   && reload_completed))
        return -1;
      return 2687; /* *fractunstahq2 */

    case 52:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode
   && reload_completed))
        return -1;
      return 2688; /* *fractunsutahq2 */

    case 53:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != HQmode
   && reload_completed))
        return -1;
      return 2689; /* *fractunsqihq2 */

    case 54:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != HQmode
   && reload_completed))
        return -1;
      return 2690; /* *fractunshihq2 */

    case 55:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != HQmode
   && reload_completed))
        return -1;
      return 2691; /* *fractunssihq2 */

    case 56:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != HQmode
   && reload_completed))
        return -1;
      return 2692; /* *fractunsdihq2 */

    case 57:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode
   && reload_completed))
        return -1;
      return 2693; /* *fractunsqquhq2 */

    case 58:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode
   && reload_completed))
        return -1;
      return 2694; /* *fractunsuqquhq2 */

    case 59:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode
   && reload_completed))
        return -1;
      return 2695; /* *fractunshquhq2 */

    case 60:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode
   && reload_completed))
        return -1;
      return 2696; /* *fractunshauhq2 */

    case 61:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode
   && reload_completed))
        return -1;
      return 2697; /* *fractunsuhauhq2 */

    case 62:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode
   && reload_completed))
        return -1;
      return 2698; /* *fractunssquhq2 */

    case 63:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode
   && reload_completed))
        return -1;
      return 2699; /* *fractunsusquhq2 */

    case 64:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode
   && reload_completed))
        return -1;
      return 2700; /* *fractunssauhq2 */

    case 65:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode
   && reload_completed))
        return -1;
      return 2701; /* *fractunsusauhq2 */

    case 66:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode
   && reload_completed))
        return -1;
      return 2702; /* *fractunsdquhq2 */

    case 67:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode
   && reload_completed))
        return -1;
      return 2703; /* *fractunsudquhq2 */

    case 68:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode
   && reload_completed))
        return -1;
      return 2704; /* *fractunsdauhq2 */

    case 69:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode
   && reload_completed))
        return -1;
      return 2705; /* *fractunsudauhq2 */

    case 70:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode
   && reload_completed))
        return -1;
      return 2706; /* *fractunstauhq2 */

    case 71:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode
   && reload_completed))
        return -1;
      return 2707; /* *fractunsutauhq2 */

    case 72:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHQmode
   && reload_completed))
        return -1;
      return 2708; /* *fractunsqiuhq2 */

    case 73:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHQmode
   && reload_completed))
        return -1;
      return 2709; /* *fractunshiuhq2 */

    case 74:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHQmode
   && reload_completed))
        return -1;
      return 2710; /* *fractunssiuhq2 */

    case 75:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHQmode
   && reload_completed))
        return -1;
      return 2711; /* *fractunsdiuhq2 */

    case 76:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HAmode
   && reload_completed))
        return -1;
      return 2712; /* *fractunsqqha2 */

    case 77:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode
   && reload_completed))
        return -1;
      return 2713; /* *fractunsuqqha2 */

    case 78:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HAmode
   && reload_completed))
        return -1;
      return 2714; /* *fractunshqha2 */

    case 79:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode
   && reload_completed))
        return -1;
      return 2715; /* *fractunsuhqha2 */

    case 80:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode
   && reload_completed))
        return -1;
      return 2716; /* *fractunsuhaha2 */

    case 81:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HAmode
   && reload_completed))
        return -1;
      return 2717; /* *fractunssqha2 */

    case 82:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HAmode
   && reload_completed))
        return -1;
      return 2718; /* *fractunsusqha2 */

    case 83:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HAmode
   && reload_completed))
        return -1;
      return 2719; /* *fractunssaha2 */

    case 84:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HAmode
   && reload_completed))
        return -1;
      return 2720; /* *fractunsusaha2 */

    case 85:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HAmode
   && reload_completed))
        return -1;
      return 2721; /* *fractunsdqha2 */

    case 86:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode
   && reload_completed))
        return -1;
      return 2722; /* *fractunsudqha2 */

    case 87:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HAmode
   && reload_completed))
        return -1;
      return 2723; /* *fractunsdaha2 */

    case 88:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode
   && reload_completed))
        return -1;
      return 2724; /* *fractunsudaha2 */

    case 89:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HAmode
   && reload_completed))
        return -1;
      return 2725; /* *fractunstaha2 */

    case 90:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode
   && reload_completed))
        return -1;
      return 2726; /* *fractunsutaha2 */

    case 91:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != HAmode
   && reload_completed))
        return -1;
      return 2727; /* *fractunsqiha2 */

    case 92:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != HAmode
   && reload_completed))
        return -1;
      return 2728; /* *fractunshiha2 */

    case 93:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != HAmode
   && reload_completed))
        return -1;
      return 2729; /* *fractunssiha2 */

    case 94:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != HAmode
   && reload_completed))
        return -1;
      return 2730; /* *fractunsdiha2 */

    case 95:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode
   && reload_completed))
        return -1;
      return 2731; /* *fractunsqquha2 */

    case 96:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode
   && reload_completed))
        return -1;
      return 2732; /* *fractunsuqquha2 */

    case 97:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode
   && reload_completed))
        return -1;
      return 2733; /* *fractunshquha2 */

    case 98:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode
   && reload_completed))
        return -1;
      return 2734; /* *fractunsuhquha2 */

    case 99:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode
   && reload_completed))
        return -1;
      return 2735; /* *fractunshauha2 */

    case 100:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode
   && reload_completed))
        return -1;
      return 2736; /* *fractunssquha2 */

    case 101:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode
   && reload_completed))
        return -1;
      return 2737; /* *fractunsusquha2 */

    case 102:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode
   && reload_completed))
        return -1;
      return 2738; /* *fractunssauha2 */

    case 103:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode
   && reload_completed))
        return -1;
      return 2739; /* *fractunsusauha2 */

    case 104:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode
   && reload_completed))
        return -1;
      return 2740; /* *fractunsdquha2 */

    case 105:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode
   && reload_completed))
        return -1;
      return 2741; /* *fractunsudquha2 */

    case 106:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode
   && reload_completed))
        return -1;
      return 2742; /* *fractunsdauha2 */

    case 107:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode
   && reload_completed))
        return -1;
      return 2743; /* *fractunsudauha2 */

    case 108:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode
   && reload_completed))
        return -1;
      return 2744; /* *fractunstauha2 */

    case 109:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode
   && reload_completed))
        return -1;
      return 2745; /* *fractunsutauha2 */

    case 110:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHAmode
   && reload_completed))
        return -1;
      return 2746; /* *fractunsqiuha2 */

    case 111:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHAmode
   && reload_completed))
        return -1;
      return 2747; /* *fractunshiuha2 */

    case 112:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHAmode
   && reload_completed))
        return -1;
      return 2748; /* *fractunssiuha2 */

    case 113:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHAmode
   && reload_completed))
        return -1;
      return 2749; /* *fractunsdiuha2 */

    case 114:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SQmode
   && reload_completed))
        return -1;
      return 2750; /* *fractunsqqsq2 */

    case 115:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode
   && reload_completed))
        return -1;
      return 2751; /* *fractunsuqqsq2 */

    case 116:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SQmode
   && reload_completed))
        return -1;
      return 2752; /* *fractunshqsq2 */

    case 117:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode
   && reload_completed))
        return -1;
      return 2753; /* *fractunsuhqsq2 */

    case 118:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SQmode
   && reload_completed))
        return -1;
      return 2754; /* *fractunshasq2 */

    case 119:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode
   && reload_completed))
        return -1;
      return 2755; /* *fractunsuhasq2 */

    case 120:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SQmode
   && reload_completed))
        return -1;
      return 2756; /* *fractunsusqsq2 */

    case 121:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SQmode
   && reload_completed))
        return -1;
      return 2757; /* *fractunssasq2 */

    case 122:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SQmode
   && reload_completed))
        return -1;
      return 2758; /* *fractunsusasq2 */

    case 123:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SQmode
   && reload_completed))
        return -1;
      return 2759; /* *fractunsdqsq2 */

    case 124:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode
   && reload_completed))
        return -1;
      return 2760; /* *fractunsudqsq2 */

    case 125:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SQmode
   && reload_completed))
        return -1;
      return 2761; /* *fractunsdasq2 */

    case 126:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode
   && reload_completed))
        return -1;
      return 2762; /* *fractunsudasq2 */

    case 127:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SQmode
   && reload_completed))
        return -1;
      return 2763; /* *fractunstasq2 */

    case 128:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode
   && reload_completed))
        return -1;
      return 2764; /* *fractunsutasq2 */

    case 129:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != SQmode
   && reload_completed))
        return -1;
      return 2765; /* *fractunsqisq2 */

    case 130:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != SQmode
   && reload_completed))
        return -1;
      return 2766; /* *fractunshisq2 */

    case 131:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != SQmode
   && reload_completed))
        return -1;
      return 2767; /* *fractunssisq2 */

    case 132:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != SQmode
   && reload_completed))
        return -1;
      return 2768; /* *fractunsdisq2 */

    case 133:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USQmode
   && reload_completed))
        return -1;
      return 2769; /* *fractunsqqusq2 */

    case 134:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode
   && reload_completed))
        return -1;
      return 2770; /* *fractunsuqqusq2 */

    case 135:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USQmode
   && reload_completed))
        return -1;
      return 2771; /* *fractunshqusq2 */

    case 136:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode
   && reload_completed))
        return -1;
      return 2772; /* *fractunsuhqusq2 */

    case 137:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USQmode
   && reload_completed))
        return -1;
      return 2773; /* *fractunshausq2 */

    case 138:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode
   && reload_completed))
        return -1;
      return 2774; /* *fractunsuhausq2 */

    case 139:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USQmode
   && reload_completed))
        return -1;
      return 2775; /* *fractunssqusq2 */

    case 140:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USQmode
   && reload_completed))
        return -1;
      return 2776; /* *fractunssausq2 */

    case 141:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != USQmode
   && reload_completed))
        return -1;
      return 2777; /* *fractunsusausq2 */

    case 142:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USQmode
   && reload_completed))
        return -1;
      return 2778; /* *fractunsdqusq2 */

    case 143:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode
   && reload_completed))
        return -1;
      return 2779; /* *fractunsudqusq2 */

    case 144:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USQmode
   && reload_completed))
        return -1;
      return 2780; /* *fractunsdausq2 */

    case 145:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode
   && reload_completed))
        return -1;
      return 2781; /* *fractunsudausq2 */

    case 146:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USQmode
   && reload_completed))
        return -1;
      return 2782; /* *fractunstausq2 */

    case 147:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode
   && reload_completed))
        return -1;
      return 2783; /* *fractunsutausq2 */

    case 148:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != USQmode
   && reload_completed))
        return -1;
      return 2784; /* *fractunsqiusq2 */

    case 149:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != USQmode
   && reload_completed))
        return -1;
      return 2785; /* *fractunshiusq2 */

    case 150:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != USQmode
   && reload_completed))
        return -1;
      return 2786; /* *fractunssiusq2 */

    case 151:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != USQmode
   && reload_completed))
        return -1;
      return 2787; /* *fractunsdiusq2 */

    case 152:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SAmode
   && reload_completed))
        return -1;
      return 2788; /* *fractunsqqsa2 */

    case 153:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode
   && reload_completed))
        return -1;
      return 2789; /* *fractunsuqqsa2 */

    case 154:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SAmode
   && reload_completed))
        return -1;
      return 2790; /* *fractunshqsa2 */

    case 155:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode
   && reload_completed))
        return -1;
      return 2791; /* *fractunsuhqsa2 */

    case 156:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SAmode
   && reload_completed))
        return -1;
      return 2792; /* *fractunshasa2 */

    case 157:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode
   && reload_completed))
        return -1;
      return 2793; /* *fractunsuhasa2 */

    case 158:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SAmode
   && reload_completed))
        return -1;
      return 2794; /* *fractunssqsa2 */

    case 159:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SAmode
   && reload_completed))
        return -1;
      return 2795; /* *fractunsusqsa2 */

    case 160:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SAmode
   && reload_completed))
        return -1;
      return 2796; /* *fractunsusasa2 */

    case 161:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SAmode
   && reload_completed))
        return -1;
      return 2797; /* *fractunsdqsa2 */

    case 162:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode
   && reload_completed))
        return -1;
      return 2798; /* *fractunsudqsa2 */

    case 163:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SAmode
   && reload_completed))
        return -1;
      return 2799; /* *fractunsdasa2 */

    case 164:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode
   && reload_completed))
        return -1;
      return 2800; /* *fractunsudasa2 */

    case 165:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SAmode
   && reload_completed))
        return -1;
      return 2801; /* *fractunstasa2 */

    case 166:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode
   && reload_completed))
        return -1;
      return 2802; /* *fractunsutasa2 */

    case 167:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != SAmode
   && reload_completed))
        return -1;
      return 2803; /* *fractunsqisa2 */

    case 168:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != SAmode
   && reload_completed))
        return -1;
      return 2804; /* *fractunshisa2 */

    case 169:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != SAmode
   && reload_completed))
        return -1;
      return 2805; /* *fractunssisa2 */

    case 170:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != SAmode
   && reload_completed))
        return -1;
      return 2806; /* *fractunsdisa2 */

    case 171:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USAmode
   && reload_completed))
        return -1;
      return 2807; /* *fractunsqqusa2 */

    case 172:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode
   && reload_completed))
        return -1;
      return 2808; /* *fractunsuqqusa2 */

    case 173:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USAmode
   && reload_completed))
        return -1;
      return 2809; /* *fractunshqusa2 */

    case 174:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode
   && reload_completed))
        return -1;
      return 2810; /* *fractunsuhqusa2 */

    case 175:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USAmode
   && reload_completed))
        return -1;
      return 2811; /* *fractunshausa2 */

    case 176:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode
   && reload_completed))
        return -1;
      return 2812; /* *fractunsuhausa2 */

    case 177:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USAmode
   && reload_completed))
        return -1;
      return 2813; /* *fractunssqusa2 */

    case 178:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != USAmode
   && reload_completed))
        return -1;
      return 2814; /* *fractunsusqusa2 */

    case 179:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USAmode
   && reload_completed))
        return -1;
      return 2815; /* *fractunssausa2 */

    case 180:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USAmode
   && reload_completed))
        return -1;
      return 2816; /* *fractunsdqusa2 */

    case 181:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode
   && reload_completed))
        return -1;
      return 2817; /* *fractunsudqusa2 */

    case 182:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USAmode
   && reload_completed))
        return -1;
      return 2818; /* *fractunsdausa2 */

    case 183:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode
   && reload_completed))
        return -1;
      return 2819; /* *fractunsudausa2 */

    case 184:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USAmode
   && reload_completed))
        return -1;
      return 2820; /* *fractunstausa2 */

    case 185:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode
   && reload_completed))
        return -1;
      return 2821; /* *fractunsutausa2 */

    case 186:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != USAmode
   && reload_completed))
        return -1;
      return 2822; /* *fractunsqiusa2 */

    case 187:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != USAmode
   && reload_completed))
        return -1;
      return 2823; /* *fractunshiusa2 */

    case 188:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != USAmode
   && reload_completed))
        return -1;
      return 2824; /* *fractunssiusa2 */

    case 189:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != USAmode
   && reload_completed))
        return -1;
      return 2825; /* *fractunsdiusa2 */

    case 190:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DQmode
   && reload_completed))
        return -1;
      return 2826; /* *fractunsqqdq2 */

    case 191:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode
   && reload_completed))
        return -1;
      return 2827; /* *fractunsuqqdq2 */

    case 192:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DQmode
   && reload_completed))
        return -1;
      return 2828; /* *fractunshqdq2 */

    case 193:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode
   && reload_completed))
        return -1;
      return 2829; /* *fractunsuhqdq2 */

    case 194:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DQmode
   && reload_completed))
        return -1;
      return 2830; /* *fractunshadq2 */

    case 195:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode
   && reload_completed))
        return -1;
      return 2831; /* *fractunsuhadq2 */

    case 196:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DQmode
   && reload_completed))
        return -1;
      return 2832; /* *fractunssqdq2 */

    case 197:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DQmode
   && reload_completed))
        return -1;
      return 2833; /* *fractunsusqdq2 */

    case 198:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DQmode
   && reload_completed))
        return -1;
      return 2834; /* *fractunssadq2 */

    case 199:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DQmode
   && reload_completed))
        return -1;
      return 2835; /* *fractunsusadq2 */

    case 200:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode
   && reload_completed))
        return -1;
      return 2836; /* *fractunsudqdq2 */

    case 201:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DQmode
   && reload_completed))
        return -1;
      return 2837; /* *fractunsdadq2 */

    case 202:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode
   && reload_completed))
        return -1;
      return 2838; /* *fractunsudadq2 */

    case 203:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DQmode
   && reload_completed))
        return -1;
      return 2839; /* *fractunstadq2 */

    case 204:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode
   && reload_completed))
        return -1;
      return 2840; /* *fractunsutadq2 */

    case 205:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != DQmode
   && reload_completed))
        return -1;
      return 2841; /* *fractunsqidq2 */

    case 206:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != DQmode
   && reload_completed))
        return -1;
      return 2842; /* *fractunshidq2 */

    case 207:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != DQmode
   && reload_completed))
        return -1;
      return 2843; /* *fractunssidq2 */

    case 208:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != DQmode
   && reload_completed))
        return -1;
      return 2844; /* *fractunsdidq2 */

    case 209:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode
   && reload_completed))
        return -1;
      return 2845; /* *fractunsqqudq2 */

    case 210:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode
   && reload_completed))
        return -1;
      return 2846; /* *fractunsuqqudq2 */

    case 211:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode
   && reload_completed))
        return -1;
      return 2847; /* *fractunshqudq2 */

    case 212:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode
   && reload_completed))
        return -1;
      return 2848; /* *fractunsuhqudq2 */

    case 213:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode
   && reload_completed))
        return -1;
      return 2849; /* *fractunshaudq2 */

    case 214:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode
   && reload_completed))
        return -1;
      return 2850; /* *fractunsuhaudq2 */

    case 215:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode
   && reload_completed))
        return -1;
      return 2851; /* *fractunssqudq2 */

    case 216:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode
   && reload_completed))
        return -1;
      return 2852; /* *fractunsusqudq2 */

    case 217:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode
   && reload_completed))
        return -1;
      return 2853; /* *fractunssaudq2 */

    case 218:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode
   && reload_completed))
        return -1;
      return 2854; /* *fractunsusaudq2 */

    case 219:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode
   && reload_completed))
        return -1;
      return 2855; /* *fractunsdqudq2 */

    case 220:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode
   && reload_completed))
        return -1;
      return 2856; /* *fractunsdaudq2 */

    case 221:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode
   && reload_completed))
        return -1;
      return 2857; /* *fractunsudaudq2 */

    case 222:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode
   && reload_completed))
        return -1;
      return 2858; /* *fractunstaudq2 */

    case 223:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode
   && reload_completed))
        return -1;
      return 2859; /* *fractunsutaudq2 */

    case 224:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDQmode
   && reload_completed))
        return -1;
      return 2860; /* *fractunsqiudq2 */

    case 225:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDQmode
   && reload_completed))
        return -1;
      return 2861; /* *fractunshiudq2 */

    case 226:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDQmode
   && reload_completed))
        return -1;
      return 2862; /* *fractunssiudq2 */

    case 227:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDQmode
   && reload_completed))
        return -1;
      return 2863; /* *fractunsdiudq2 */

    case 228:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DAmode
   && reload_completed))
        return -1;
      return 2864; /* *fractunsqqda2 */

    case 229:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode
   && reload_completed))
        return -1;
      return 2865; /* *fractunsuqqda2 */

    case 230:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DAmode
   && reload_completed))
        return -1;
      return 2866; /* *fractunshqda2 */

    case 231:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode
   && reload_completed))
        return -1;
      return 2867; /* *fractunsuhqda2 */

    case 232:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DAmode
   && reload_completed))
        return -1;
      return 2868; /* *fractunshada2 */

    case 233:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode
   && reload_completed))
        return -1;
      return 2869; /* *fractunsuhada2 */

    case 234:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DAmode
   && reload_completed))
        return -1;
      return 2870; /* *fractunssqda2 */

    case 235:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DAmode
   && reload_completed))
        return -1;
      return 2871; /* *fractunsusqda2 */

    case 236:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DAmode
   && reload_completed))
        return -1;
      return 2872; /* *fractunssada2 */

    case 237:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DAmode
   && reload_completed))
        return -1;
      return 2873; /* *fractunsusada2 */

    case 238:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DAmode
   && reload_completed))
        return -1;
      return 2874; /* *fractunsdqda2 */

    case 239:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode
   && reload_completed))
        return -1;
      return 2875; /* *fractunsudqda2 */

    case 240:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode
   && reload_completed))
        return -1;
      return 2876; /* *fractunsudada2 */

    case 241:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DAmode
   && reload_completed))
        return -1;
      return 2877; /* *fractunstada2 */

    case 242:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode
   && reload_completed))
        return -1;
      return 2878; /* *fractunsutada2 */

    case 243:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != DAmode
   && reload_completed))
        return -1;
      return 2879; /* *fractunsqida2 */

    case 244:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != DAmode
   && reload_completed))
        return -1;
      return 2880; /* *fractunshida2 */

    case 245:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != DAmode
   && reload_completed))
        return -1;
      return 2881; /* *fractunssida2 */

    case 246:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != DAmode
   && reload_completed))
        return -1;
      return 2882; /* *fractunsdida2 */

    case 247:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode
   && reload_completed))
        return -1;
      return 2883; /* *fractunsqquda2 */

    case 248:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode
   && reload_completed))
        return -1;
      return 2884; /* *fractunsuqquda2 */

    case 249:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode
   && reload_completed))
        return -1;
      return 2885; /* *fractunshquda2 */

    case 250:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode
   && reload_completed))
        return -1;
      return 2886; /* *fractunsuhquda2 */

    case 251:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode
   && reload_completed))
        return -1;
      return 2887; /* *fractunshauda2 */

    case 252:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode
   && reload_completed))
        return -1;
      return 2888; /* *fractunsuhauda2 */

    case 253:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode
   && reload_completed))
        return -1;
      return 2889; /* *fractunssquda2 */

    case 254:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode
   && reload_completed))
        return -1;
      return 2890; /* *fractunsusquda2 */

    case 255:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode
   && reload_completed))
        return -1;
      return 2891; /* *fractunssauda2 */

    case 256:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode
   && reload_completed))
        return -1;
      return 2892; /* *fractunsusauda2 */

    case 257:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode
   && reload_completed))
        return -1;
      return 2893; /* *fractunsdquda2 */

    case 258:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode
   && reload_completed))
        return -1;
      return 2894; /* *fractunsudquda2 */

    case 259:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode
   && reload_completed))
        return -1;
      return 2895; /* *fractunsdauda2 */

    case 260:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode
   && reload_completed))
        return -1;
      return 2896; /* *fractunstauda2 */

    case 261:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode
   && reload_completed))
        return -1;
      return 2897; /* *fractunsutauda2 */

    case 262:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDAmode
   && reload_completed))
        return -1;
      return 2898; /* *fractunsqiuda2 */

    case 263:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDAmode
   && reload_completed))
        return -1;
      return 2899; /* *fractunshiuda2 */

    case 264:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDAmode
   && reload_completed))
        return -1;
      return 2900; /* *fractunssiuda2 */

    case 265:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDAmode
   && reload_completed))
        return -1;
      return 2901; /* *fractunsdiuda2 */

    case 266:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != TAmode
   && reload_completed))
        return -1;
      return 2902; /* *fractunsqqta2 */

    case 267:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode
   && reload_completed))
        return -1;
      return 2903; /* *fractunsuqqta2 */

    case 268:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != TAmode
   && reload_completed))
        return -1;
      return 2904; /* *fractunshqta2 */

    case 269:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode
   && reload_completed))
        return -1;
      return 2905; /* *fractunsuhqta2 */

    case 270:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != TAmode
   && reload_completed))
        return -1;
      return 2906; /* *fractunshata2 */

    case 271:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode
   && reload_completed))
        return -1;
      return 2907; /* *fractunsuhata2 */

    case 272:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != TAmode
   && reload_completed))
        return -1;
      return 2908; /* *fractunssqta2 */

    case 273:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != TAmode
   && reload_completed))
        return -1;
      return 2909; /* *fractunsusqta2 */

    case 274:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != TAmode
   && reload_completed))
        return -1;
      return 2910; /* *fractunssata2 */

    case 275:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != TAmode
   && reload_completed))
        return -1;
      return 2911; /* *fractunsusata2 */

    case 276:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != TAmode
   && reload_completed))
        return -1;
      return 2912; /* *fractunsdqta2 */

    case 277:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode
   && reload_completed))
        return -1;
      return 2913; /* *fractunsudqta2 */

    case 278:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != TAmode
   && reload_completed))
        return -1;
      return 2914; /* *fractunsdata2 */

    case 279:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode
   && reload_completed))
        return -1;
      return 2915; /* *fractunsudata2 */

    case 280:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode
   && reload_completed))
        return -1;
      return 2916; /* *fractunsutata2 */

    case 281:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != TAmode
   && reload_completed))
        return -1;
      return 2917; /* *fractunsqita2 */

    case 282:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != TAmode
   && reload_completed))
        return -1;
      return 2918; /* *fractunshita2 */

    case 283:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != TAmode
   && reload_completed))
        return -1;
      return 2919; /* *fractunssita2 */

    case 284:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != TAmode
   && reload_completed))
        return -1;
      return 2920; /* *fractunsdita2 */

    case 285:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode
   && reload_completed))
        return -1;
      return 2921; /* *fractunsqquta2 */

    case 286:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode
   && reload_completed))
        return -1;
      return 2922; /* *fractunsuqquta2 */

    case 287:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode
   && reload_completed))
        return -1;
      return 2923; /* *fractunshquta2 */

    case 288:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode
   && reload_completed))
        return -1;
      return 2924; /* *fractunsuhquta2 */

    case 289:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode
   && reload_completed))
        return -1;
      return 2925; /* *fractunshauta2 */

    case 290:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode
   && reload_completed))
        return -1;
      return 2926; /* *fractunsuhauta2 */

    case 291:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode
   && reload_completed))
        return -1;
      return 2927; /* *fractunssquta2 */

    case 292:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode
   && reload_completed))
        return -1;
      return 2928; /* *fractunsusquta2 */

    case 293:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode
   && reload_completed))
        return -1;
      return 2929; /* *fractunssauta2 */

    case 294:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode
   && reload_completed))
        return -1;
      return 2930; /* *fractunsusauta2 */

    case 295:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode
   && reload_completed))
        return -1;
      return 2931; /* *fractunsdquta2 */

    case 296:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode
   && reload_completed))
        return -1;
      return 2932; /* *fractunsudquta2 */

    case 297:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode
   && reload_completed))
        return -1;
      return 2933; /* *fractunsdauta2 */

    case 298:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode
   && reload_completed))
        return -1;
      return 2934; /* *fractunsudauta2 */

    case 299:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode
   && reload_completed))
        return -1;
      return 2935; /* *fractunstauta2 */

    case 300:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UTAmode
   && reload_completed))
        return -1;
      return 2936; /* *fractunsqiuta2 */

    case 301:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UTAmode
   && reload_completed))
        return -1;
      return 2937; /* *fractunshiuta2 */

    case 302:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UTAmode
   && reload_completed))
        return -1;
      return 2938; /* *fractunssiuta2 */

    case 303:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UTAmode
   && reload_completed))
        return -1;
      return 2939; /* *fractunsdiuta2 */

    case 304:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != QImode
   && reload_completed))
        return -1;
      return 2940; /* *fractunsqqqi2 */

    case 305:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QImode
   && reload_completed))
        return -1;
      return 2941; /* *fractunsuqqqi2 */

    case 306:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QImode
   && reload_completed))
        return -1;
      return 2942; /* *fractunshqqi2 */

    case 307:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QImode
   && reload_completed))
        return -1;
      return 2943; /* *fractunsuhqqi2 */

    case 308:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QImode
   && reload_completed))
        return -1;
      return 2944; /* *fractunshaqi2 */

    case 309:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QImode
   && reload_completed))
        return -1;
      return 2945; /* *fractunsuhaqi2 */

    case 310:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QImode
   && reload_completed))
        return -1;
      return 2946; /* *fractunssqqi2 */

    case 311:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QImode
   && reload_completed))
        return -1;
      return 2947; /* *fractunsusqqi2 */

    case 312:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QImode
   && reload_completed))
        return -1;
      return 2948; /* *fractunssaqi2 */

    case 313:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QImode
   && reload_completed))
        return -1;
      return 2949; /* *fractunsusaqi2 */

    case 314:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QImode
   && reload_completed))
        return -1;
      return 2950; /* *fractunsdqqi2 */

    case 315:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QImode
   && reload_completed))
        return -1;
      return 2951; /* *fractunsudqqi2 */

    case 316:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QImode
   && reload_completed))
        return -1;
      return 2952; /* *fractunsdaqi2 */

    case 317:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QImode
   && reload_completed))
        return -1;
      return 2953; /* *fractunsudaqi2 */

    case 318:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QImode
   && reload_completed))
        return -1;
      return 2954; /* *fractunstaqi2 */

    case 319:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QImode
   && reload_completed))
        return -1;
      return 2955; /* *fractunsutaqi2 */

    case 320:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != QImode
   && reload_completed))
        return -1;
      return 2956; /* *fractunshiqi2 */

    case 321:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != QImode
   && reload_completed))
        return -1;
      return 2957; /* *fractunssiqi2 */

    case 322:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != QImode
   && reload_completed))
        return -1;
      return 2958; /* *fractunsdiqi2 */

    case 323:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HImode
   && reload_completed))
        return -1;
      return 2959; /* *fractunsqqhi2 */

    case 324:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HImode
   && reload_completed))
        return -1;
      return 2960; /* *fractunsuqqhi2 */

    case 325:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HImode
   && reload_completed))
        return -1;
      return 2961; /* *fractunshqhi2 */

    case 326:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HImode
   && reload_completed))
        return -1;
      return 2962; /* *fractunsuhqhi2 */

    case 327:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HImode
   && reload_completed))
        return -1;
      return 2963; /* *fractunshahi2 */

    case 328:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HImode
   && reload_completed))
        return -1;
      return 2964; /* *fractunsuhahi2 */

    case 329:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HImode
   && reload_completed))
        return -1;
      return 2965; /* *fractunssqhi2 */

    case 330:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HImode
   && reload_completed))
        return -1;
      return 2966; /* *fractunsusqhi2 */

    case 331:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HImode
   && reload_completed))
        return -1;
      return 2967; /* *fractunssahi2 */

    case 332:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HImode
   && reload_completed))
        return -1;
      return 2968; /* *fractunsusahi2 */

    case 333:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HImode
   && reload_completed))
        return -1;
      return 2969; /* *fractunsdqhi2 */

    case 334:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HImode
   && reload_completed))
        return -1;
      return 2970; /* *fractunsudqhi2 */

    case 335:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HImode
   && reload_completed))
        return -1;
      return 2971; /* *fractunsdahi2 */

    case 336:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HImode
   && reload_completed))
        return -1;
      return 2972; /* *fractunsudahi2 */

    case 337:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HImode
   && reload_completed))
        return -1;
      return 2973; /* *fractunstahi2 */

    case 338:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HImode
   && reload_completed))
        return -1;
      return 2974; /* *fractunsutahi2 */

    case 339:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != HImode
   && reload_completed))
        return -1;
      return 2975; /* *fractunsqihi2 */

    case 340:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != HImode
   && reload_completed))
        return -1;
      return 2976; /* *fractunssihi2 */

    case 341:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != HImode
   && reload_completed))
        return -1;
      return 2977; /* *fractunsdihi2 */

    case 342:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SImode
   && reload_completed))
        return -1;
      return 2978; /* *fractunsqqsi2 */

    case 343:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SImode
   && reload_completed))
        return -1;
      return 2979; /* *fractunsuqqsi2 */

    case 344:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SImode
   && reload_completed))
        return -1;
      return 2980; /* *fractunshqsi2 */

    case 345:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SImode
   && reload_completed))
        return -1;
      return 2981; /* *fractunsuhqsi2 */

    case 346:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SImode
   && reload_completed))
        return -1;
      return 2982; /* *fractunshasi2 */

    case 347:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SImode
   && reload_completed))
        return -1;
      return 2983; /* *fractunsuhasi2 */

    case 348:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SImode
   && reload_completed))
        return -1;
      return 2984; /* *fractunssqsi2 */

    case 349:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SImode
   && reload_completed))
        return -1;
      return 2985; /* *fractunsusqsi2 */

    case 350:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SImode
   && reload_completed))
        return -1;
      return 2986; /* *fractunssasi2 */

    case 351:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SImode
   && reload_completed))
        return -1;
      return 2987; /* *fractunsusasi2 */

    case 352:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SImode
   && reload_completed))
        return -1;
      return 2988; /* *fractunsdqsi2 */

    case 353:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SImode
   && reload_completed))
        return -1;
      return 2989; /* *fractunsudqsi2 */

    case 354:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SImode
   && reload_completed))
        return -1;
      return 2990; /* *fractunsdasi2 */

    case 355:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SImode
   && reload_completed))
        return -1;
      return 2991; /* *fractunsudasi2 */

    case 356:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SImode
   && reload_completed))
        return -1;
      return 2992; /* *fractunstasi2 */

    case 357:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SImode
   && reload_completed))
        return -1;
      return 2993; /* *fractunsutasi2 */

    case 358:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != SImode
   && reload_completed))
        return -1;
      return 2994; /* *fractunsqisi2 */

    case 359:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != SImode
   && reload_completed))
        return -1;
      return 2995; /* *fractunshisi2 */

    case 360:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != SImode
   && reload_completed))
        return -1;
      return 2996; /* *fractunsdisi2 */

    case 361:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DImode
   && reload_completed))
        return -1;
      return 2997; /* *fractunsqqdi2 */

    case 362:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DImode
   && reload_completed))
        return -1;
      return 2998; /* *fractunsuqqdi2 */

    case 363:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DImode
   && reload_completed))
        return -1;
      return 2999; /* *fractunshqdi2 */

    case 364:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DImode
   && reload_completed))
        return -1;
      return 3000; /* *fractunsuhqdi2 */

    case 365:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DImode
   && reload_completed))
        return -1;
      return 3001; /* *fractunshadi2 */

    case 366:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DImode
   && reload_completed))
        return -1;
      return 3002; /* *fractunsuhadi2 */

    case 367:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DImode
   && reload_completed))
        return -1;
      return 3003; /* *fractunssqdi2 */

    case 368:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DImode
   && reload_completed))
        return -1;
      return 3004; /* *fractunsusqdi2 */

    case 369:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DImode
   && reload_completed))
        return -1;
      return 3005; /* *fractunssadi2 */

    case 370:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DImode
   && reload_completed))
        return -1;
      return 3006; /* *fractunsusadi2 */

    case 371:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DImode
   && reload_completed))
        return -1;
      return 3007; /* *fractunsdqdi2 */

    case 372:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DImode
   && reload_completed))
        return -1;
      return 3008; /* *fractunsudqdi2 */

    case 373:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DImode
   && reload_completed))
        return -1;
      return 3009; /* *fractunsdadi2 */

    case 374:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DImode
   && reload_completed))
        return -1;
      return 3010; /* *fractunsudadi2 */

    case 375:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DImode
   && reload_completed))
        return -1;
      return 3011; /* *fractunstadi2 */

    case 376:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DImode
   && reload_completed))
        return -1;
      return 3012; /* *fractunsutadi2 */

    case 377:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != DImode
   && reload_completed))
        return -1;
      return 3013; /* *fractunsqidi2 */

    case 378:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != DImode
   && reload_completed))
        return -1;
      return 3014; /* *fractunshidi2 */

    case 379:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != DImode
   && reload_completed))
        return -1;
      return 3015; /* *fractunssidi2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      switch (pattern93 (x1))
        {
        case 0:
          if (!(
#line 10172 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))) && 
#line 10174 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_678 (insn, operands);

        case 1:
          if (!(
#line 10548 "../../gcc/config/avr/avr.md"
(! reload_completed
   && ((1 << INTVAL (operands[3])) & INTVAL (operands[2])) != 0) && 
#line 10551 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_754 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern182 (x2))
        {
        case 0:
          if (
#line 10426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_732 (insn, operands);
          break;

        case 1:
          if (
#line 10426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_733 (insn, operands);
          break;

        case 2:
          if (
#line 10426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_734 (insn, operands);
          break;

        case 3:
          if (
#line 10426 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_735 (insn, operands);
          break;

        case 4:
          return gen_split_736 (insn, operands);

        case 5:
          return gen_split_737 (insn, operands);

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG)
        return NULL;
      switch (pattern138 (x1))
        {
        case 0:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_742 (insn, operands);

        case 1:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_746 (insn, operands);

        case 2:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_750 (insn, operands);

        case 3:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_743 (insn, operands);

        case 4:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_747 (insn, operands);

        case 5:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_751 (insn, operands);

        case 6:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_744 (insn, operands);

        case 7:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_748 (insn, operands);

        case 8:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_752 (insn, operands);

        case 9:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_745 (insn, operands);

        case 10:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_749 (insn, operands);

        case 11:
          if (!(
#line 10525 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10531 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_753 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      if (pattern94 (x1) != 0
          || !
#line 10480 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_738 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_33 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_26 (x1, insn);

    case PLUS:
      return split_27 (x1, insn);

    case MINUS:
      return split_28 (x1, insn);

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != REG)
            return NULL;
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x3, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          switch (REGNO (x5))
            {
            case 24:
              if (pattern287 (x1) != 0
                  || !(
#line 2243 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2245 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_163 (insn, operands);

            case 22:
              if (pattern288 (x1) != 0
                  || !(
#line 3719 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3721 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_335 (insn, operands);

            case 18:
              switch (pattern289 (x1))
                {
                case 0:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1836 (insn, operands);

                case 1:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1837 (insn, operands);

                case 2:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1838 (insn, operands);

                case 3:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1839 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern183 (x1) != 0)
            return NULL;
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2998 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3000 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_298 (insn, operands);
          if (u8_operand (operands[2], E_HImode)
              && (
#line 3034 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3036 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_301 (insn, operands);
          if (!o8_operand (operands[2], E_HImode)
              || !(
#line 3052 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3054 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_302 (insn, operands);

        case ZERO_EXTEND:
          if (pattern183 (x1) != 0)
            return NULL;
          if (u8_operand (operands[2], E_HImode)
              && (
#line 2998 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3000 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_299 (insn, operands);
          if (!s8_operand (operands[2], E_HImode)
              || !(
#line 3016 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3018 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_300 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      return split_29 (x1, insn);

    case TRUNCATE:
      if (GET_MODE (x4) != E_HImode
          || pattern184 (x1, 
E_HImode, 
24) != 0)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != MULT
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return NULL;
          x8 = XEXP (x3, 0);
          if (REGNO (x8) != 22
              || GET_MODE (x8) != E_HImode)
            return NULL;
          switch (pattern365 (x9))
            {
            case 0:
              if (!(
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3806 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_339 (insn, operands);

            case 1:
              if (!(
#line 3804 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3806 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_340 (insn, operands);

            default:
              return NULL;
            }

        case CLZ:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 22
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x8 = XEXP (x3, 0);
          if (REGNO (x8) != 26
              || GET_MODE (x8) != E_QImode
              || !
#line 9444 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_659 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 4513 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_368 (insn, operands);

        case 1:
          if (!
#line 4547 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_369 (insn, operands);

        case 2:
          if (!
#line 4582 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_370 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 4661 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_372 (insn, operands);

        case 1:
          if (!
#line 4693 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_373 (insn, operands);

        case 2:
          if (!
#line 4725 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_374 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 4782 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_376 (insn, operands);

        case 1:
          if (!
#line 4812 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_377 (insn, operands);

        case 2:
          if (!
#line 4844 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_378 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (pattern257 (x1))
        {
        case 0:
          if ((
#line 5236 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5241 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_403 (insn, operands);
          if (!(
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5265 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_405 (insn, operands);

        case 1:
          if (!(
#line 5236 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5241 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_404 (insn, operands);

        case 2:
          if (!(
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5265 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_407 (insn, operands);

        case 3:
          if (!(
#line 5259 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5265 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_406 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern258 (x1))
            {
            case 0:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_447 (insn, operands);
              break;

            case 1:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_450 (insn, operands);
              break;

            case 2:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return gen_split_453 (insn, operands);
              break;

            case 3:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_456 (insn, operands);
              break;

            case 4:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_459 (insn, operands);
              break;

            case 5:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_462 (insn, operands);
              break;

            case 6:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_465 (insn, operands);
              break;

            case 7:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_468 (insn, operands);
              break;

            case 8:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_471 (insn, operands);
              break;

            case 9:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_474 (insn, operands);
              break;

            case 10:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_477 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern259 (x1) != 0
          || !
#line 6068 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_544 (insn, operands);

    case ASHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern258 (x1))
            {
            case 0:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_448 (insn, operands);
              break;

            case 1:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_451 (insn, operands);
              break;

            case 2:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return gen_split_454 (insn, operands);
              break;

            case 3:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_457 (insn, operands);
              break;

            case 4:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_460 (insn, operands);
              break;

            case 5:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_463 (insn, operands);
              break;

            case 6:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_466 (insn, operands);
              break;

            case 7:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_469 (insn, operands);
              break;

            case 8:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_472 (insn, operands);
              break;

            case 9:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_475 (insn, operands);
              break;

            case 10:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_478 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern259 (x1) != 0
          || !
#line 5868 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_523 (insn, operands);

    case LO_SUM:
      if (GET_MODE (x4) != E_PSImode
          || pattern171 (x1) != 0
          || !
#line 6673 "../../gcc/config/avr/avr.md"
(reload_completed))
        return NULL;
      return gen_split_572 (insn, operands);

    case COMPARE:
      if (GET_MODE (x4) != E_CCmode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LSHIFTRT)
        return NULL;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 36
          || GET_MODE (x7) != E_CCmode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != SCRATCH
          || GET_MODE (x8) != E_QImode)
        return NULL;
      switch (pattern330 (x5))
        {
        case 0:
          if (!(
#line 6947 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6951 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_578 (insn, operands);

        case 1:
          if (!(
#line 6947 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6951 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_579 (insn, operands);

        case 2:
          if (!(
#line 6947 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6951 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_580 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x5 = XEXP (x4, 0);
      if (!ordered_comparison_operator (x5, E_VOIDmode))
        return NULL;
      operands[0] = x5;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return NULL;
      x11 = XEXP (x4, 2);
      if (GET_CODE (x11) != PC)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PC)
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern295 (x1))
        {
        case 0:
          if (
#line 7055 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_584 (insn, operands);
          break;

        case 1:
          if (
#line 7055 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_585 (insn, operands);
          break;

        case 2:
          if (
#line 7055 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_586 (insn, operands);
          break;

        case 3:
          if (
#line 7055 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_587 (insn, operands);
          break;

        case 4:
          if (
#line 7055 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_588 (insn, operands);
          break;

        case 5:
          if (
#line 7082 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_589 (insn, operands);
          break;

        case 6:
          if (
#line 7110 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_590 (insn, operands);
          break;

        case 7:
          if (
#line 7110 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_591 (insn, operands);
          break;

        case 8:
          if (
#line 7110 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_592 (insn, operands);
          break;

        case 9:
          if (
#line 7110 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_593 (insn, operands);
          break;

        case 10:
          if (
#line 7110 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_594 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x9) != REG)
        return NULL;
      switch (pattern296 (x1))
        {
        case 0:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1940 (insn, operands);

        case 1:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1941 (insn, operands);

        case 2:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1942 (insn, operands);

        case 3:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1943 (insn, operands);

        case 4:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1944 (insn, operands);

        case 5:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1945 (insn, operands);

        case 6:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1946 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24)
        return NULL;
      switch (pattern229 (x1))
        {
        case 0:
          if (!(
#line 9179 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9181 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_647 (insn, operands);

        case 1:
          if (!(
#line 9208 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9210 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_649 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PARITY
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_HImode)
        return NULL;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode))
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 9194 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9196 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_648 (insn, operands);

    case CLZ:
      if (pattern155 (x1) != 0
          || !
#line 9423 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_658 (insn, operands);

    case CTZ:
      if (pattern155 (x1) != 0
          || !
#line 9492 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_660 (insn, operands);

    case FFS:
      if (pattern155 (x1) != 0
          || !
#line 9564 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_662 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2)
        return NULL;
      x12 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x12) != REG)
        return NULL;
      x13 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x13) != REG
          || GET_MODE (x13) != E_QImode)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return NULL;
      switch (pattern299 (x1))
        {
        case 0:
          if (!(
#line 9768 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9770 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_666 (insn, operands);

        case 1:
          if (!(
#line 9840 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9842 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_668 (insn, operands);

        case 2:
          if (!(
#line 9912 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9914 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_670 (insn, operands);

        case 3:
          if (!
#line 716 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1868 (insn, operands);

        case 4:
          if (!
#line 716 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1869 (insn, operands);

        case 5:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1870 (insn, operands);

        case 6:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1871 (insn, operands);

        case 7:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1872 (insn, operands);

        case 8:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1873 (insn, operands);

        case 9:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1874 (insn, operands);

        case 10:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1875 (insn, operands);

        case 11:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1876 (insn, operands);

        case 12:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1877 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern156 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1842 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1844 (insn, operands);

        default:
          return NULL;
        }

    case DIV:
      switch (pattern156 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1843 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1845 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
