/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ZERO_EXTEND
          || GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      return 1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  return 0;
}

int
pattern24 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != 24)
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HQmode:
      if (GET_MODE (x2) != E_HQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_HQmode
          || GET_MODE (x3) != E_HQmode)
        return -1;
      return 0;

    case E_UHQmode:
      if (GET_MODE (x2) != E_UHQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UHQmode
          || GET_MODE (x3) != E_UHQmode)
        return -1;
      return 1;

    case E_HAmode:
      if (GET_MODE (x2) != E_HAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_HAmode
          || GET_MODE (x3) != E_HAmode)
        return -1;
      return 2;

    case E_UHAmode:
      if (GET_MODE (x2) != E_UHAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UHAmode
          || GET_MODE (x3) != E_UHAmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern36 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || pattern35 (x1, 
E_SImode, 
22) != 0)
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!low_io_address_operand (operands[0], E_VOIDmode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_8_16_24_operand (operands[3], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      res = pattern4 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || GET_MODE (x5) != E_UDQmode)
            return -1;
          return 0;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || GET_MODE (x5) != E_UDAmode)
            return -1;
          return 1;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || GET_MODE (x5) != E_UTAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || !const_operand (operands[0], E_UDQmode))
            return -1;
          return 3;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || !const_operand (operands[0], E_UDAmode))
            return -1;
          return 4;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || !const_operand (operands[0], E_UTAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  return pattern75 (x1); /* [-1, 3] */
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          return pattern78 (x1, 
E_HImode); /* [-1, 0] */

        case E_PSImode:
          if (pattern78 (x1, 
E_PSImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern78 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_QImode:
          if (pattern79 (x1) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      res = pattern47 (x1);
      if (res >= 0)
        return res + 4; /* [4, 9] */
      return -1;

    case XOR:
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      x7 = XEXP (x1, 1);
      operands[3] = x7;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case NE:
    case EQ:
      operands[0] = x6;
      if (!eqne_operator (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[3] = x7;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case ZERO_EXTRACT:
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x10 = XEXP (x8, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x11 = XEXP (x8, 0);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[1] = x11;
              if (!register_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 0;

                case E_HImode:
                  return 1;

                case E_PSImode:
                  return 2;

                case E_SImode:
                  return 3;

                case E_DImode:
                  return 4;

                default:
                  return -1;
                }

            case MEM:
              if (GET_MODE (x11) != E_QImode)
                return -1;
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 5;

                case E_HImode:
                  return 6;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          switch (GET_MODE (x8))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !single_one_operand (operands[2], E_QImode))
                return -1;
              return 7;

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !single_one_operand (operands[2], E_HImode))
                return -1;
              return 8;

            case E_PSImode:
              if (!register_operand (operands[1], E_PSImode)
                  || !single_one_operand (operands[2], E_PSImode))
                return -1;
              return 9;

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !single_one_operand (operands[2], E_SImode))
                return -1;
              return 10;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GE:
    case LT:
      return 11;

    default:
      return -1;
    }
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern139 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !pseudo_register_operand (operands[1], i1)
      || !pseudo_register_operand (operands[2], i1)
      || !pseudo_register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern145 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      if (pnum_clobbers == NULL
          || REGNO (x4) != 22)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 24)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 22)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 24:
          return pattern142 (x1, 
E_QImode, 
25); /* [-1, 0] */

        case 22:
          if (pattern142 (x1, 
E_HImode, 
24) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (pnum_clobbers == NULL
          || REGNO (x4) != 18)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 22)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 18)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 22:
          if (pattern142 (x1, 
E_PSImode, 
18) != 0)
            return -1;
          return 2;

        case 18:
          if (pattern142 (x1, 
E_SImode, 
22) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 25:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      res = pattern144 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_PSImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!const_int_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  return 0;
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!d_register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      if (!d_register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      if (!d_register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LO_SUM
      || GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 21
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22)
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode
      || !register_operand (operands[3], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern202 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (XWINT (x6, 0) != 8LL)
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode
      || GET_MODE (x3) != E_HImode
      || GET_MODE (x4) != E_HImode)
    return -1;
  x8 = XEXP (x4, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[2] = x10;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern210 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_QImode)
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_QImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern224 (x3, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern224 (x3, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern224 (x3, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern224 (x3, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern235 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[1], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_HQmode)
        return -1;
      return 0;

    case E_UHQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_UHQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_UHQmode)
        return -1;
      return 1;

    case E_HAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_HAmode)
        return -1;
      return 2;

    case E_UHAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_UHAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_UHAmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XINT (x5, 1) != 6
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return pattern251 (x1); /* [-1, 1] */
}

int
pattern256 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern261 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x1, 0);
  if (REGNO (x5) != i3
      || GET_MODE (x5) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern267 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode
      || !register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern273 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  return pattern272 (x1); /* [-1, 1] */
}

int
pattern276 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      return pattern275 (
E_QImode); /* [-1, 1] */

    case E_HImode:
      res = pattern275 (
E_HImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != E_HImode)
    return -1;
  return pattern282 (x1, 
i1, 
i2); /* [-1, 3] */
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_SImode
      || pattern207 (x1, 
E_SImode, 
E_HImode, 
22, 
26) != 0)
    return -1;
  return 0;
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[1], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 1);
  switch (GET_CODE (x9))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || GET_MODE (x7) != E_SImode)
            return -1;
          return pattern274 (); /* [-1, 1] */

        case E_PSImode:
          if (!pseudo_register_operand (operands[0], E_PSImode)
              || GET_MODE (x6) != E_PSImode
              || GET_MODE (x7) != E_PSImode
              || !pseudo_register_operand (operands[1], E_QImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_PSImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern309 (x6);
      if (res >= 0)
        return res + 3; /* [3, 6] */
      return -1;

    case ZERO_EXTEND:
      res = pattern309 (x6);
      if (res >= 0)
        return res + 7; /* [7, 10] */
      return -1;

    default:
      return -1;
    }
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!l_register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      if (!l_register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      if (!l_register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22
      || GET_MODE (x5) != E_SImode
      || pattern316 (x1, 
E_QImode, 
26, 
22) != 0)
    return -1;
  return 0;
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 25
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  return pattern143 (x6); /* [-1, 1] */
}

int
pattern347 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i3
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i2
      || GET_MODE (x7) != E_HImode
      || pattern139 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern352 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  if (!const_int_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  x12 = XVECEXP (x1, 0, 5);
  x13 = XEXP (x12, 0);
  operands[5] = x13;
  if (!scratch_operand (operands[5], E_QImode))
    return -1;
  x14 = XEXP (x4, 1);
  x15 = XVECEXP (x14, 0, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  return 0;
}

int
pattern364 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 18
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 26
      || GET_MODE (x5) != E_HImode)
    return -1;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1)
      || !nonmemory_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1)
      || !nonmemory_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern377 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (REGNO (x6) != i5
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i4
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (REGNO (x10) != i5
      || GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 0);
  if (REGNO (x11) != i4
      || GET_MODE (x11) != i1
      || pattern376 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern387 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1)
      || !const_int_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1)
      || !const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern391 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!l_register_operand (operands[0], i1)
      || !const_operand (operands[1], i1)
      || !l_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern395 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[3], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern394 (x1); /* [-1, 0] */

    case NE:
      if (pattern394 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern394 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern394 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern394 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern394 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == REG
      && REGNO (x2) == 22)
    {
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (pattern158 (x2))
        {
        case 0:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 5; /* load_qi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 20; /* *load_qi_libgcc */
            }
          break;

        case 1:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 6; /* load_qq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 21; /* *load_qq_libgcc */
            }
          break;

        case 2:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 7; /* load_uqq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 22; /* *load_uqq_libgcc */
            }
          break;

        case 3:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 8; /* load_hi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 23; /* *load_hi_libgcc */
            }
          break;

        case 4:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 9; /* load_hq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 24; /* *load_hq_libgcc */
            }
          break;

        case 5:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 10; /* load_uhq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 25; /* *load_uhq_libgcc */
            }
          break;

        case 6:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 11; /* load_ha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 26; /* *load_ha_libgcc */
            }
          break;

        case 7:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 12; /* load_uha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 27; /* *load_uha_libgcc */
            }
          break;

        case 8:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 13; /* load_si_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 28; /* *load_si_libgcc */
            }
          break;

        case 9:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 14; /* load_sq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 29; /* *load_sq_libgcc */
            }
          break;

        case 10:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 15; /* load_usq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 30; /* *load_usq_libgcc */
            }
          break;

        case 11:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 16; /* load_sa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 31; /* *load_sa_libgcc */
            }
          break;

        case 12:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 17; /* load_usa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 32; /* *load_usa_libgcc */
            }
          break;

        case 13:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 18; /* load_sf_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 33; /* *load_sf_libgcc */
            }
          break;

        case 14:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 19; /* load_psi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 34; /* *load_psi_libgcc */
            }
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern122 (x3))
    {
    case 0:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 35; /* fxmovqi_A */

    case 1:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 36; /* fxmovqq_A */

    case 2:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 37; /* fxmovuqq_A */

    case 3:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 38; /* fxmovhi_A */

    case 4:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 39; /* fxmovhq_A */

    case 5:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 40; /* fxmovuhq_A */

    case 6:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 41; /* fxmovha_A */

    case 7:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 42; /* fxmovuha_A */

    case 8:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 43; /* fxmovsi_A */

    case 9:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 44; /* fxmovsq_A */

    case 10:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 45; /* fxmovusq_A */

    case 11:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 46; /* fxmovsa_A */

    case 12:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 47; /* fxmovusa_A */

    case 13:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 48; /* fxmovsf_A */

    case 14:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 49; /* fxmovpsi_A */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern67 (x2))
        {
        case 0:
          return 172; /* *strlenhi_split */

        case 1:
          return 1011; /* insert_bits */

        case 2:
          return 3126; /* roundqq3_const */

        case 3:
          return 3127; /* roundhq3_const */

        case 4:
          return 3128; /* roundha3_const */

        case 5:
          return 3129; /* roundsa3_const */

        case 6:
          return 3130; /* roundsq3_const */

        case 7:
          return 3131; /* rounduqq3_const */

        case 8:
          return 3132; /* rounduhq3_const */

        case 9:
          return 3133; /* rounduha3_const */

        case 10:
          return 3134; /* roundusa3_const */

        case 11:
          return 3135; /* roundusq3_const */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 4:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9742 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1057; /* fmul_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9757 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1058; /* *fmul_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9768 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1059; /* *fmul.call_split */
            }
          if (!
#line 9783 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1060; /* *fmul.call */

        case 5:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9814 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1061; /* fmuls_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9829 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1062; /* *fmuls_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9840 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1063; /* *fmuls.call_split */
            }
          if (!
#line 9855 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1064; /* *fmuls.call */

        case 6:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9886 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1065; /* fmulsu_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9901 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1066; /* *fmulsu_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9912 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1067; /* *fmulsu.call_split */
            }
          if (!
#line 9927 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1068; /* *fmulsu.call */

        case 8:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != REG)
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 24
              || GET_MODE (x5) != E_QImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG)
            return -1;
          switch (REGNO (x4))
            {
            case 22:
              if (REGNO (x3) != 24)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_QQmode:
                  if (GET_MODE (x2) != E_QQmode
                      || GET_MODE (x4) != E_QQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3146; /* *roundqq3.libgcc_split */

                case E_UQQmode:
                  if (GET_MODE (x2) != E_UQQmode
                      || GET_MODE (x4) != E_UQQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3147; /* *rounduqq3.libgcc_split */

                case E_HQmode:
                  if (GET_MODE (x2) != E_HQmode
                      || GET_MODE (x4) != E_HQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3150; /* *roundhq3.libgcc_split */

                case E_UHQmode:
                  if (GET_MODE (x2) != E_UHQmode
                      || GET_MODE (x4) != E_UHQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3151; /* *rounduhq3.libgcc_split */

                case E_HAmode:
                  if (GET_MODE (x2) != E_HAmode
                      || GET_MODE (x4) != E_HAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3152; /* *roundha3.libgcc_split */

                case E_UHAmode:
                  if (GET_MODE (x2) != E_UHAmode
                      || GET_MODE (x4) != E_UHAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3153; /* *rounduha3.libgcc_split */

                default:
                  return -1;
                }

            case 18:
              if (REGNO (x3) != 22)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_SQmode:
                  if (GET_MODE (x2) != E_SQmode
                      || GET_MODE (x4) != E_SQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3158; /* *roundsq3.libgcc_split */

                case E_USQmode:
                  if (GET_MODE (x2) != E_USQmode
                      || GET_MODE (x4) != E_USQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3159; /* *roundusq3.libgcc_split */

                case E_SAmode:
                  if (GET_MODE (x2) != E_SAmode
                      || GET_MODE (x4) != E_SAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3160; /* *roundsa3.libgcc_split */

                case E_USAmode:
                  if (GET_MODE (x2) != E_USAmode
                      || GET_MODE (x4) != E_USAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3161; /* *roundusa3.libgcc_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 3
          || GET_MODE (x2) != E_QImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != IOR
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[3] = x9;
      if (!register_operand (operands[3], E_QImode)
          || !
#line 11169 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
        return -1;
      *pnum_clobbers = 1;
      return 1495; /* *nzb=1.ior.ashift */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (pattern74 (x1, pnum_clobbers))
        {
        case 0:
          return 618; /* andqi3 */

        case 1:
          *pnum_clobbers = 1;
          return 620; /* andhi3 */

        case 2:
          *pnum_clobbers = 1;
          return 622; /* andpsi3 */

        case 3:
          *pnum_clobbers = 1;
          return 624; /* andsi3 */

        default:
          break;
        }
      if (GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern220 (x2))
        {
        case 0:
          if (!
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1210; /* *extract.subreg.bit */

        case 1:
          if (!
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1212; /* *extract.subreg.bit */

        case 2:
          if (!
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1214; /* *extract.subreg.bit */

        case 3:
          if (!
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1211; /* *extract.subreg.bit */

        case 4:
          if (!
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1213; /* *extract.subreg.bit */

        case 5:
          if (!
#line 10671 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1215; /* *extract.subreg.bit */

        default:
          return -1;
        }

    case MEM:
      if (pattern40 (x1) != 0
          || !single_zero_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      return 980; /* *cbi */

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern76 (x2))
        {
        case 0:
          return 1182; /* *insv.any_shift.qi_split */

        case 1:
          return 1185; /* *insv.any_shift.hi_split */

        case 2:
          return 1188; /* *insv.any_shift.psi_split */

        case 3:
          return 1191; /* *insv.any_shift.si_split */

        case 4:
          if (!
#line 11027 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && avr_nonzero_bits_lsr_operands_p (AND, operands)))
            return -1;
          return 1481; /* *nzb=1.and.lsr_split */

        case 5:
          if (!
#line 11077 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && avr_nonzero_bits_lsr_operands_p (AND, operands)))
            return -1;
          return 1487; /* *nzb=1.and.lsr.not_split */

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern77 (x2))
        {
        case 0:
          return 1183; /* *insv.any_shift.qi_split */

        case 1:
          return 1186; /* *insv.any_shift.hi_split */

        case 2:
          return 1189; /* *insv.any_shift.psi_split */

        case 3:
          return 1192; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern77 (x2))
        {
        case 0:
          return 1184; /* *insv.any_shift.qi_split */

        case 1:
          return 1187; /* *insv.any_shift.hi_split */

        case 2:
          return 1190; /* *insv.any_shift.psi_split */

        case 3:
          return 1193; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern135 (x2))
        {
        case 0:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1457; /* *map.and1-to-skip.qi */

        case 1:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1461; /* *map.and1-to-skip.qi */

        case 2:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1465; /* *map.and1-to-skip.qi */

        case 3:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1469; /* *map.and1-to-skip.qi */

        case 4:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1458; /* *map.and1-to-skip.hi */

        case 5:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1462; /* *map.and1-to-skip.hi */

        case 6:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1466; /* *map.and1-to-skip.hi */

        case 7:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1470; /* *map.and1-to-skip.hi */

        case 8:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1459; /* *map.and1-to-skip.psi */

        case 9:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1463; /* *map.and1-to-skip.psi */

        case 10:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1467; /* *map.and1-to-skip.psi */

        case 11:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1471; /* *map.and1-to-skip.psi */

        case 12:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1460; /* *map.and1-to-skip.si */

        case 13:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1464; /* *map.and1-to-skip.si */

        case 14:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1468; /* *map.and1-to-skip.si */

        case 15:
          if (!
#line 10953 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1472; /* *map.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10982 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (AND == IOR || AND == XOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1475; /* *nzb=1.and.zerox_split */

        case 1:
          if (!
#line 11051 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && (AND == IOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1484; /* *nzb=1.and.zerox.not_split */

        default:
          return -1;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11101 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (AND == IOR || AND == XOR
       || nonzero_bits (operands[2], QImode) == 1)))
        return -1;
      return 1490; /* *nzb=1.and.ge0_split */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      switch (pattern223 (x1))
        {
        case 0:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 258; /* *subhi3.sign_extend.qi */

        case 1:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 260; /* *subpsi3.sign_extend.qi */

        case 2:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 264; /* *subpsi3.sign_extend.hi */

        case 3:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 262; /* *subsi3.sign_extend.qi */

        case 4:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 266; /* *subsi3.sign_extend.hi */

        case 5:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 268; /* *subsi3.sign_extend.psi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern223 (x1))
        {
        case 0:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 259; /* *subhi3.zero_extend.qi */

        case 1:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 261; /* *subpsi3.zero_extend.qi */

        case 2:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 265; /* *subpsi3.zero_extend.hi */

        case 3:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 263; /* *subsi3.zero_extend.qi */

        case 4:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 267; /* *subsi3.zero_extend.hi */

        case 5:
          if (!
#line 2038 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 269; /* *subsi3.zero_extend.psi */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) == REG
          && REGNO (x7) == 36
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_PSImode:
              if (pattern328 (x3, 
E_PSImode) == 0
                  && 
#line 2092 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 273; /* *subpsi3 */
              break;

            case E_QImode:
              if (pattern315 (x3, 
E_QImode) == 0
                  && 
#line 2119 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 277; /* *subqi3 */
              break;

            case E_QQmode:
              if (pattern315 (x3, 
E_QQmode) == 0
                  && 
#line 2119 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 278; /* *subqq3 */
              break;

            case E_UQQmode:
              if (pattern315 (x3, 
E_UQQmode) == 0
                  && 
#line 2119 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 279; /* *subuqq3 */
              break;

            default:
              break;
            }
        }
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern315 (x3, 
E_HImode) != 0)
            return -1;
          return 280; /* subhi3 */

        case E_HQmode:
          if (pattern315 (x3, 
E_HQmode) != 0)
            return -1;
          return 281; /* subhq3 */

        case E_UHQmode:
          if (pattern315 (x3, 
E_UHQmode) != 0)
            return -1;
          return 282; /* subuhq3 */

        case E_HAmode:
          if (pattern315 (x3, 
E_HAmode) != 0)
            return -1;
          return 283; /* subha3 */

        case E_UHAmode:
          if (pattern315 (x3, 
E_UHAmode) != 0)
            return -1;
          return 284; /* subuha3 */

        case E_SImode:
          if (pattern315 (x3, 
E_SImode) != 0)
            return -1;
          return 290; /* subsi3 */

        case E_SQmode:
          if (pattern315 (x3, 
E_SQmode) != 0)
            return -1;
          return 291; /* subsq3 */

        case E_USQmode:
          if (pattern315 (x3, 
E_USQmode) != 0)
            return -1;
          return 292; /* subusq3 */

        case E_SAmode:
          if (pattern315 (x3, 
E_SAmode) != 0)
            return -1;
          return 293; /* subsa3 */

        case E_USAmode:
          if (pattern315 (x3, 
E_USAmode) != 0)
            return -1;
          return 294; /* subusa3 */

        default:
          return -1;
        }

    case GE:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 348; /* *subqi3.ge0 */

        case 1:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 356; /* *subqi3.ge0 */

        case 2:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 364; /* *subqi3.ge0 */

        case 3:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 372; /* *subqi3.ge0 */

        case 4:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 350; /* *subhi3.ge0 */

        case 5:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 358; /* *subhi3.ge0 */

        case 6:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 366; /* *subhi3.ge0 */

        case 7:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 374; /* *subhi3.ge0 */

        case 8:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 352; /* *subpsi3.ge0 */

        case 9:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 360; /* *subpsi3.ge0 */

        case 10:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 368; /* *subpsi3.ge0 */

        case 11:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 376; /* *subpsi3.ge0 */

        case 12:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 354; /* *subsi3.ge0 */

        case 13:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 362; /* *subsi3.ge0 */

        case 14:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 370; /* *subsi3.ge0 */

        case 15:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 378; /* *subsi3.ge0 */

        default:
          return -1;
        }

    case LT:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 349; /* *subqi3.lt0 */

        case 1:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 357; /* *subqi3.lt0 */

        case 2:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 365; /* *subqi3.lt0 */

        case 3:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 373; /* *subqi3.lt0 */

        case 4:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 351; /* *subhi3.lt0 */

        case 5:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 359; /* *subhi3.lt0 */

        case 6:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 367; /* *subhi3.lt0 */

        case 7:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 375; /* *subhi3.lt0 */

        case 8:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 353; /* *subpsi3.lt0 */

        case 9:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 361; /* *subpsi3.lt0 */

        case 10:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 369; /* *subpsi3.lt0 */

        case 11:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 377; /* *subpsi3.lt0 */

        case 12:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 355; /* *subsi3.lt0 */

        case 13:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 363; /* *subsi3.lt0 */

        case 14:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 371; /* *subsi3.lt0 */

        case 15:
          if (!
#line 2374 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 379; /* *subsi3.lt0 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x3, 0);
      operands[3] = x5;
      switch (pattern240 (x3))
        {
        case 0:
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 36
                  || GET_MODE (x7) != E_CCmode
                  || !
#line 2637 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 493; /* *msubqi4 */

            case CONST_INT:
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2666 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 495; /* *msubqi4.const */

            default:
              return -1;
            }

        case 1:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTEND:
              if (pattern369 (x1) != 0
                  || !
#line 2749 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 502; /* *msubqihi4 */

            case ZERO_EXTEND:
              if (pattern369 (x1) != 0
                  || !
#line 2815 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              return 511; /* *sumsubqihi4 */

            case CONST_INT:
              operands[2] = x8;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode))
                return -1;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2881 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 515; /* *msubqihi4.sconst */
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2972 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              return 520; /* *sumsubqihi4.uconst */

            default:
              return -1;
            }

        case 2:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              if (pattern369 (x1) != 0
                  || !
#line 2749 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 503; /* *umsubqihi4 */

            case SIGN_EXTEND:
              if (pattern369 (x1) != 0
                  || !
#line 2815 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              return 510; /* *usmsubqihi4 */

            case CONST_INT:
              operands[2] = x8;
              if (!u8_operand (operands[2], E_HImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2881 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 516; /* *umsubqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern226 (x3) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!scratch_operand (operands[4], E_QImode))
        return -1;
      x9 = XEXP (x4, 0);
      switch (pattern359 (x9))
        {
        case 0:
          if (!
#line 2904 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 517; /* *umsubqihi4.uconst.ashift */

        case 1:
          if (!
#line 2928 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 518; /* *msubqihi4.sconst.ashift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      if (XWINT (x6, 0) == 1LL)
        {
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) == REG
              && REGNO (x9) == 36
              && GET_MODE (x9) == E_CCmode
              && 
#line 3085 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 527; /* *ashiftqihi2.signx.1 */
        }
      x9 = XEXP (x2, 0);
      if (!scratch_operand (x9, E_QImode))
        return -1;
      operands[3] = x9;
      operands[2] = x6;
      if (const_2_to_6_operand (operands[2], E_HImode)
          && 
#line 3096 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 528; /* *ashifthi3.signx.const */
      operands[2] = x9;
      if (XWINT (x6, 0) != 7LL
          || !
#line 3114 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 529; /* *ashifthi3.signx.const7 */

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (pattern228 (x1) != 0
          || !
#line 3132 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 530; /* *ashifthi3.zerox.const */

    case REG:
    case SUBREG:
      operands[1] = x5;
      res = recog_46 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3332; /* *ashldi3_insn */

        case 1:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3336; /* *ashldq3_insn */

        case 2:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3340; /* *ashludq3_insn */

        case 3:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3344; /* *ashlda3_insn */

        case 4:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3348; /* *ashluda3_insn */

        case 5:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3352; /* *ashlta3_insn */

        case 6:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3356; /* *ashluta3_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern99 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode)
          || !
#line 6491 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 807; /* *extendqihi2 */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!combine_pseudo_register_operand (operands[1], E_QImode)
              || !
#line 6512 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 809; /* *extendqipsi2 */

        case E_HImode:
          if (!combine_pseudo_register_operand (operands[1], E_HImode)
              || !
#line 6554 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 813; /* *extendhipsi2 */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!combine_pseudo_register_operand (operands[1], E_QImode)
              || !
#line 6533 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 811; /* *extendqisi2 */

        case E_HImode:
          if (!combine_pseudo_register_operand (operands[1], E_HImode)
              || !
#line 6575 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 815; /* *extendhisi2 */

        case E_PSImode:
          if (!combine_pseudo_register_operand (operands[1], E_PSImode)
              || !
#line 6596 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 817; /* *extendpsisi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_HImode))
    return -1;
  if (
#line 7968 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL))
    return 974; /* *tablejump_split */
  if (pnum_clobbers == NULL
      || !
#line 7989 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL && reload_completed))
    return -1;
  *pnum_clobbers = 1;
  return 975; /* *tablejump */
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 119; /* *reload_inqi */

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 120; /* *reload_inqq */

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 885 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 121; /* *reload_inuqq */

    case E_HImode:
      if (!l_register_operand (operands[0], E_HImode)
          || !immediate_operand (operands[1], E_HImode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 123; /* *reload_inhi */

    case E_HQmode:
      if (!l_register_operand (operands[0], E_HQmode)
          || !immediate_operand (operands[1], E_HQmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 124; /* *reload_inhq */

    case E_UHQmode:
      if (!l_register_operand (operands[0], E_UHQmode)
          || !immediate_operand (operands[1], E_UHQmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 125; /* *reload_inuhq */

    case E_HAmode:
      if (!l_register_operand (operands[0], E_HAmode)
          || !immediate_operand (operands[1], E_HAmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 126; /* *reload_inha */

    case E_UHAmode:
      if (!l_register_operand (operands[0], E_UHAmode)
          || !immediate_operand (operands[1], E_UHAmode)
          || !
#line 950 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 127; /* *reload_inuha */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1125 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 138; /* *reload_inpsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 141; /* *reload_insi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 142; /* *reload_insi */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 143; /* *reload_insi */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 144; /* *reload_insi */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1182 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 145; /* *reload_insi */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1283 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 159; /* *reload_insf */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (pattern104 (x4, 
23) != 0
      || pattern313 (x1) != 0)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 24
      || pattern27 (x1) != 0)
    return -1;
  x7 = XVECEXP (x1, 0, 6);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 24
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (pattern393 (x9, 
E_QImode, 
23) != 0)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_QImode)
    return -1;
  x12 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 36
      || GET_MODE (x13) != E_CCmode)
    return -1;
  x14 = XVECEXP (x1, 0, 1);
  x15 = XVECEXP (x14, 0, 0);
  operands[0] = x15;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x16 = XEXP (x11, 0);
  operands[1] = x16;
  if (!io_address_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_QImode:
      if (!
#line 1416 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 166; /* *cpymemx_qi */

    case E_HImode:
      if (!
#line 1416 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 167; /* *cpymemx_hi */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_89 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_72 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_77 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_84 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 7:
          res = recog_85 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          if (pattern28 (x1) == 0)
            {
              x2 = XVECEXP (x1, 0, 7);
              if (pattern393 (x2, 
E_CCmode, 
36) == 0)
                {
                  switch (pattern392 (x1))
                    {
                    case 0:
                      if (
#line 1351 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 162; /* *cpymem_qi */
                      break;

                    case 1:
                      if (
#line 1351 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 163; /* *cpymem_hi */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case 9:
          switch (pattern29 (x1))
            {
            case 0:
              return 164; /* cpymemx_qi */

            case 1:
              return 165; /* cpymemx_hi */

            default:
              break;
            }
          break;

        case 10:
          res = recog_86 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_87 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_88 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 6)
        return -1;
      operands[0] = x1;
      if (!set_some_operation (operands[0], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE
          || pattern177 (x1, 
USE) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!dreg_or_0_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[5] = x12;
      if (!register_operand (operands[5], E_QImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[6] = x13;
      if (!const_int_operand (operands[6], E_QImode)
          || !
#line 1229 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 156; /* set_some */

    case CONST_INT:
      if (XWINT (x1, 0) != 0LL)
        return -1;
      return 972; /* nop */

    case RETURN:
      if (
#line 8720 "../../gcc/config/avr/avr.md"
(reload_completed && avr_simple_epilogue ()))
        return 999; /* return */
      if (
#line 8726 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && !(cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1000; /* return_from_epilogue */
      if (
#line 8735 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && (cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1001; /* return_from_interrupt_epilogue */
      if (!
#line 8744 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && cfun->machine->is_naked))
        return -1;
      return 1002; /* return_from_naked_epilogue */

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_HImode))
    return NULL;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return NULL;
  x5 = XEXP (x3, 1);
  switch (pattern286 (x5))
    {
    case 0:
      if (!(
#line 2469 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2471 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_271 (insn, operands);

    case 1:
      if (!(
#line 2517 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2519 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_274 (insn, operands);

    case 2:
      if (!(
#line 3153 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3155 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_307 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern196 (x2) != 0
              || !(
#line 2469 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2471 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_272 (insn, operands);

        case E_PSImode:
          switch (pattern197 (x2))
            {
            case 0:
              if (!(
#line 4112 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4114 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            case 1:
              if (!(
#line 4139 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4141 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_354 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_QImode)
          || !(
#line 2492 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2494 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_273 (insn, operands);

    case REG:
    case SUBREG:
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 3178 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3180 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_308 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  if (pattern125 (x3) != 0)
    return NULL;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return NULL;
  x8 = XEXP (x3, 1);
  switch (pattern286 (x8))
    {
    case 0:
      if (!(
#line 2542 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2544 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_275 (insn, operands);

    case 1:
      if (!(
#line 2566 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2568 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_276 (insn, operands);

    case 2:
      if (!(
#line 3205 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3207 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_309 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0))
    return NULL;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode)
          || !
#line 5283 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 2 > 1))
        return NULL;
      return gen_split_408 (insn, operands);

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || GET_MODE (x3) != E_PSImode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !
#line 5283 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 3 > 1))
            return NULL;
          return gen_split_409 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !
#line 5283 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 3 > 2))
            return NULL;
          return gen_split_411 (insn, operands);

        default:
          return NULL;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !
#line 5283 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 4 > 1))
            return NULL;
          return gen_split_410 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !
#line 5283 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 4 > 2))
            return NULL;
          return gen_split_412 (insn, operands);

        case E_PSImode:
          if (!nonimmediate_operand (operands[1], E_PSImode)
              || !
#line 5283 "../../gcc/config/avr/avr.md"
(!reload_completed
   && !avropt_lra_p
   && 4 > 3))
            return NULL;
          return gen_split_413 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern90 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern263 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && nonmemory_operand (operands[2], E_QImode)
                  && 
#line 7033 "../../gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_581 (insn, operands);
              break;

            case E_QQmode:
              if (register_operand (operands[1], E_QQmode)
                  && nonmemory_operand (operands[2], E_QQmode)
                  && 
#line 7033 "../../gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_582 (insn, operands);
              break;

            case E_UQQmode:
              if (register_operand (operands[1], E_UQQmode)
                  && nonmemory_operand (operands[2], E_UQQmode)
                  && 
#line 7033 "../../gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_583 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case 1:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_607 (insn, operands);
          break;

        case 2:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_609 (insn, operands);
          break;

        case 3:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_613 (insn, operands);
          break;

        case 4:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_611 (insn, operands);
          break;

        case 5:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_615 (insn, operands);
          break;

        case 6:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_617 (insn, operands);
          break;

        case 7:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_608 (insn, operands);
          break;

        case 8:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_610 (insn, operands);
          break;

        case 9:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_614 (insn, operands);
          break;

        case 10:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_612 (insn, operands);
          break;

        case 11:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_616 (insn, operands);
          break;

        case 12:
          if ((
#line 7166 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7169 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_618 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 18)
        return NULL;
      x5 = XEXP (x2, 1);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 10)
            return NULL;
          switch (pattern336 (x3))
            {
            case 0:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1932 (insn, operands);

            case 1:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1933 (insn, operands);

            case 2:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1934 (insn, operands);

            case 3:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1935 (insn, operands);

            case 4:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1936 (insn, operands);

            case 5:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1937 (insn, operands);

            case 6:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1938 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern302 (x3) != 0
              || !(
#line 529 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 531 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1939 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x2 = XEXP (x1, 1);
      switch (pattern236 (x2))
        {
        case 0:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_595 (insn, operands);

        case 1:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_597 (insn, operands);

        case 2:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_601 (insn, operands);

        case 3:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_599 (insn, operands);

        case 4:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_603 (insn, operands);

        case 5:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_605 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x2 = XEXP (x1, 1);
      switch (pattern236 (x2))
        {
        case 0:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_596 (insn, operands);

        case 1:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_598 (insn, operands);

        case 2:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_602 (insn, operands);

        case 3:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_600 (insn, operands);

        case 4:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_604 (insn, operands);

        case 5:
          if (!(
#line 7135 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7138 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_606 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern194 (x2, 
E_QImode) == 0
              && (
#line 2209 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2211 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_162 (insn, operands);
          break;

        case E_HImode:
          if (pattern194 (x2, 
E_HImode) == 0
              && (
#line 3277 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3279 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_310 (insn, operands);
          break;

        case E_QQmode:
          if (pattern194 (x2, 
E_QQmode) == 0
              && (
#line 296 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 298 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return gen_split_1833 (insn, operands);
          break;

        case E_UQQmode:
          if (pattern194 (x2, 
E_UQQmode) == 0
              && (
#line 317 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 319 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return gen_split_1834 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 16
          || GET_CODE (x5) != REG
          || REGNO (x5) != 20
          || GET_CODE (x4) != REG)
        return NULL;
      switch (pattern25 (x1, 
24))
        {
        case 0:
          if (!(
#line 468 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 470 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return NULL;
          return gen_split_1840 (insn, operands);

        case 1:
          if (!(
#line 468 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 470 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return NULL;
          return gen_split_1841 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (register_operand (operands[1], E_QImode))
            {
              res = split_3 (x1, insn);
              if (res != NULL_RTX)
                return res;
            }
          if (GET_CODE (x6) != REG)
            return NULL;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG)
            return NULL;
          switch (REGNO (x6))
            {
            case 18:
              if (GET_MODE (x6) != E_HImode)
                return NULL;
              x5 = XEXP (x2, 1);
              if (GET_CODE (x5) != SIGN_EXTEND
                  || pattern255 (x5, 
E_HImode, 
E_SImode) != 0
                  || pattern200 (x1, 
E_SImode, 
22) != 0
                  || !(
#line 3779 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3781 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_337 (insn, operands);

            case 26:
              if (pattern201 (x1, 
E_SImode, 
22, 
18, 
E_HImode) != 0
                  || !(
#line 3850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3852 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_342 (insn, operands);

            case 25:
              if (pattern201 (x1, 
E_PSImode, 
18, 
22, 
E_QImode) != 0
                  || !(
#line 4229 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4231 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_357 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_987 (insn, operands);

        case 2:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_989 (insn, operands);

        case 3:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_993 (insn, operands);

        case 4:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_991 (insn, operands);

        case 5:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_995 (insn, operands);

        case 6:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_997 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG)
            return NULL;
          switch (pattern133 (x1))
            {
            case 0:
              if (!(
#line 3779 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3781 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_338 (insn, operands);

            case 1:
              if (!(
#line 3829 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3831 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_341 (insn, operands);

            case 2:
              if (!(
#line 3850 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3852 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_343 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_988 (insn, operands);

        case 2:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_990 (insn, operands);

        case 3:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_994 (insn, operands);

        case 4:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_992 (insn, operands);

        case 5:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_996 (insn, operands);

        case 6:
          if (!(
#line 10909 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10913 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_998 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ZERO_EXTEND)
        return NULL;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != NOT)
        return NULL;
      if (GET_MODE (x7) == E_QImode)
        {
          res = split_5 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      if (GET_MODE (x7) != E_HImode
          || pattern163 (x1) != 0
          || !(
#line 3871 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3873 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_344 (insn, operands);

    case AND:
      switch (pattern33 (x1))
        {
        case 0:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_967 (insn, operands);

        case 1:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_971 (insn, operands);

        case 2:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_975 (insn, operands);

        case 3:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_979 (insn, operands);

        case 4:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_968 (insn, operands);

        case 5:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_972 (insn, operands);

        case 6:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_976 (insn, operands);

        case 7:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_980 (insn, operands);

        case 8:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_969 (insn, operands);

        case 9:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_973 (insn, operands);

        case 10:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_977 (insn, operands);

        case 11:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_981 (insn, operands);

        case 12:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_970 (insn, operands);

        case 13:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_974 (insn, operands);

        case 14:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_978 (insn, operands);

        case 15:
          if (!(
#line 10879 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10882 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_982 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern17 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern88 (x1))
        {
        case 0:
          if (
#line 6262 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_552 (insn, operands);
          break;

        case 1:
          if (
#line 6298 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_554 (insn, operands);
          break;

        case 2:
          if (
#line 6318 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_555 (insn, operands);
          break;

        case 3:
          if (
#line 6339 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_556 (insn, operands);
          break;

        case 4:
          if (
#line 6373 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_557 (insn, operands);
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case SUBREG:
          switch (pattern89 (x1))
            {
            case 0:
              if (!(
#line 10586 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10588 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_759 (insn, operands);

            case 1:
              if (!(
#line 10586 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10588 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_760 (insn, operands);

            case 2:
              if (!(
#line 10586 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10588 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_761 (insn, operands);

            case 3:
              if (!(
#line 10586 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10588 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_762 (insn, operands);

            default:
              return NULL;
            }

        case REG:
          if (REGNO (x3) != 18
              || GET_MODE (x3) != E_DImode
              || pattern34 (x1, 
E_DImode, 
18) != 0
              || !(
#line 421 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 423 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1931 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!
#line 6280 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_553 (insn, operands);

    case 2:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_802 (insn, operands);

    case 3:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_803 (insn, operands);

    case 4:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_804 (insn, operands);

    case 5:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_805 (insn, operands);

    case 6:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_806 (insn, operands);

    case 7:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_807 (insn, operands);

    case 8:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_808 (insn, operands);

    case 9:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_809 (insn, operands);

    case 10:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_814 (insn, operands);

    case 11:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_815 (insn, operands);

    case 12:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_816 (insn, operands);

    case 13:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_817 (insn, operands);

    case 14:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_810 (insn, operands);

    case 15:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_811 (insn, operands);

    case 16:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_812 (insn, operands);

    case 17:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_813 (insn, operands);

    case 18:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_818 (insn, operands);

    case 19:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_819 (insn, operands);

    case 20:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_820 (insn, operands);

    case 21:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_821 (insn, operands);

    case 22:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_822 (insn, operands);

    case 23:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_823 (insn, operands);

    case 24:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_824 (insn, operands);

    case 25:
      if (!(
#line 10714 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10718 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_825 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (pattern152 (x3))
    {
    case 0:
      if (
#line 5810 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_515 (insn, operands);
      break;

    case 1:
      if (
#line 5810 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_516 (insn, operands);
      break;

    case 2:
      if (
#line 5810 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_517 (insn, operands);
      break;

    case 3:
      if (
#line 5837 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_518 (insn, operands);
      break;

    case 4:
      if (
#line 5837 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_519 (insn, operands);
      break;

    case 5:
      if (
#line 5837 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_520 (insn, operands);
      break;

    case 6:
      if (
#line 5837 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_521 (insn, operands);
      break;

    case 7:
      if (
#line 5837 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_522 (insn, operands);
      break;

    case 8:
      if (
#line 5900 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_524 (insn, operands);
      break;

    case 9:
      if (
#line 5900 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_525 (insn, operands);
      break;

    case 10:
      if (
#line 5900 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_526 (insn, operands);
      break;

    case 11:
      if (
#line 5900 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_527 (insn, operands);
      break;

    case 12:
      if (
#line 5900 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_528 (insn, operands);
      break;

    default:
      break;
    }
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return NULL;
  switch (pattern87 (x1))
    {
    case 0:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1948 (insn, operands);

    case 1:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1952 (insn, operands);

    case 2:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1956 (insn, operands);

    case 3:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1960 (insn, operands);

    case 4:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1964 (insn, operands);

    case 5:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1968 (insn, operands);

    case 6:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1972 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_29 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return NULL;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return NULL;
      operands[2] = x6;
      if (const_2_to_6_operand (operands[2], E_HImode)
          && register_operand (operands[0], E_HImode)
          && GET_MODE (x4) == E_HImode)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (register_operand (operands[1], E_QImode))
            {
              x8 = XVECEXP (x1, 0, 1);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (scratch_operand (operands[3], E_QImode)
                  && (
#line 3096 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3098 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_304 (insn, operands);
            }
        }
      if (XWINT (x6, 0) != 7LL
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode)
        return NULL;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!scratch_operand (operands[2], E_QImode)
          || !(
#line 3114 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3116 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_305 (insn, operands);

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode
          || pattern228 (x1) != 0
          || !(
#line 3132 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3134 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_306 (insn, operands);

    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern258 (x1))
            {
            case 0:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_449 (insn, operands);
              break;

            case 1:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_452 (insn, operands);
              break;

            case 2:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3l (operands[2])))
                return gen_split_455 (insn, operands);
              break;

            case 3:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_458 (insn, operands);
              break;

            case 4:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_461 (insn, operands);
              break;

            case 5:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_464 (insn, operands);
              break;

            case 6:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_467 (insn, operands);
              break;

            case 7:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_470 (insn, operands);
              break;

            case 8:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_473 (insn, operands);
              break;

            case 9:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_476 (insn, operands);
              break;

            case 10:
              if (
#line 5630 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_479 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern259 (x1) != 0
          || !
#line 5751 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_513 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode
      || !d_register_operand (operands[0], E_QImode))
    return NULL;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_QImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = PATTERN (peep2_next_insn (1));
  if (pattern323 (x6, 
E_QImode, 
AND) != 0)
    return NULL;
  x7 = XVECEXP (x6, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return NULL;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return NULL;
  x11 = XEXP (x7, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_42 (insn, operands);
}

 rtx_insn *
peephole2_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 0);
  if (pattern326 (x5) != 0)
    return NULL;
  x6 = PATTERN (peep2_next_insn (1));
  switch (pattern390 (x6))
    {
    case 0:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_HImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern401 (x12, 
E_HImode))
        {
        case 0:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_134 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_135 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_136 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_137 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_138 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_139 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern402 (x12, 
E_HImode))
        {
        case 0:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_170 (insn, operands);

        case 1:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_171 (insn, operands);

        case 2:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_172 (insn, operands);

        case 3:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_173 (insn, operands);

        case 4:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_174 (insn, operands);

        case 5:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_175 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_PSImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern401 (x12, 
E_PSImode))
        {
        case 0:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_140 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_141 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_142 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_143 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_144 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_145 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern402 (x12, 
E_PSImode))
        {
        case 0:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_176 (insn, operands);

        case 1:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_177 (insn, operands);

        case 2:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_178 (insn, operands);

        case 3:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_179 (insn, operands);

        case 4:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_180 (insn, operands);

        case 5:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_181 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_SImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern401 (x12, 
E_SImode))
        {
        case 0:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_146 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_147 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_148 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_149 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_150 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7285 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_151 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern402 (x12, 
E_SImode))
        {
        case 0:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_182 (insn, operands);

        case 1:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_183 (insn, operands);

        case 2:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_184 (insn, operands);

        case 3:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_185 (insn, operands);

        case 4:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_186 (insn, operands);

        case 5:
          if (!
#line 7348 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_187 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      res = peephole2_1 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      if (peep2_current_count < 2
          || x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern211 (x1, 
E_QImode) != 0)
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (pattern323 (x5, 
E_QImode, 
IOR) != 0)
        return NULL;
      x6 = XVECEXP (x5, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return NULL;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_308 (insn, operands);

    case REG:
      return peephole2_5 (x1, insn, pmatch_len_);

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
      x11 = XEXP (x3, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 36
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XEXP (x2, 0);
      operands[0] = x12;
      switch (GET_CODE (x4))
        {
        case AND:
          res = peephole2_2 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case ASHIFT:
          x13 = XEXP (x4, 1);
          switch (GET_CODE (x13))
            {
            case REG:
            case SUBREG:
              operands[1] = x13;
              if (register_operand (operands[1], E_QImode)
                  && register_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode)
                {
                  x14 = XEXP (x4, 0);
                  if (rtx_equal_p (x14, operands[0]))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_85 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case CONST_INT:
              x14 = XEXP (x4, 0);
              if (rtx_equal_p (x14, operands[0]))
                {
                  switch (XWINT (x13, 0))
                    {
                    case 4LL:
                      switch (pattern335 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_86 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_87 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_88 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 5LL:
                      switch (pattern335 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_89 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_90 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_91 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 6LL:
                      switch (pattern335 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_92 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_93 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_94 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x13;
              switch (pattern325 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_97 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_100 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_103 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_106 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_109 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_112 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_115 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_118 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_121 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_124 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case LSHIFTRT:
          x13 = XEXP (x4, 1);
          if (GET_CODE (x13) == CONST_INT)
            {
              operands[2] = x13;
              switch (pattern325 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_95 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_98 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_101 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_104 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_107 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_110 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_113 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_116 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_119 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_122 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
              x14 = XEXP (x4, 0);
              if (rtx_equal_p (x14, operands[0]))
                {
                  switch (XWINT (x13, 0))
                    {
                    case 4LL:
                      switch (pattern335 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_125 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_126 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_127 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 5LL:
                      switch (pattern335 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_128 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_129 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_130 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 6LL:
                      switch (pattern335 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_131 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_132 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_133 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case ASHIFTRT:
          x14 = XEXP (x4, 0);
          operands[1] = x14;
          x13 = XEXP (x4, 1);
          operands[2] = x13;
          if (const_int_operand (operands[2], E_QImode))
            {
              switch (pattern324 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_96 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_99 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_102 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_105 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_108 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_111 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_114 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_117 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_120 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_123 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
            }
          break;

        case PLUS:
          res = peephole2_3 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case MINUS:
          res = peephole2_4 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (peep2_current_count < 2
          || peep2_current_count < 3
          || !register_operand (operands[0], E_QImode))
        return NULL;
      operands[2] = x4;
      if (!op8_ZN_operator (operands[2], E_QImode))
        return NULL;
      x13 = XEXP (x4, 1);
      operands[1] = x13;
      x14 = XEXP (x4, 0);
      if (!rtx_equal_p (x14, operands[0]))
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x5) != SET)
        return NULL;
      x15 = XEXP (x5, 1);
      if (GET_CODE (x15) != COMPARE
          || GET_MODE (x15) != E_CCmode)
        return NULL;
      x16 = XEXP (x5, 0);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 36
          || GET_MODE (x16) != E_CCmode)
        return NULL;
      x17 = XEXP (x15, 1);
      operands[4] = x17;
      if (!const0_operand (operands[4], E_QImode))
        return NULL;
      x18 = XEXP (x15, 0);
      if (!rtx_equal_p (x18, operands[0]))
        return NULL;
      x19 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x19) != SET)
        return NULL;
      x20 = XEXP (x19, 1);
      if (GET_CODE (x20) != IF_THEN_ELSE)
        return NULL;
      x21 = XEXP (x20, 1);
      if (GET_CODE (x21) != LABEL_REF)
        return NULL;
      x22 = XEXP (x20, 2);
      if (GET_CODE (x22) != PC)
        return NULL;
      x23 = XEXP (x19, 0);
      if (GET_CODE (x23) != PC)
        return NULL;
      x24 = XEXP (x21, 0);
      operands[3] = x24;
      x25 = XEXP (x20, 0);
      switch (GET_CODE (x25))
        {
        case EQ:
          if (pattern394 (x25) != 0
              || !
#line 7601 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_284 (insn, operands);

        case NE:
          if (pattern394 (x25) != 0
              || !
#line 7601 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_285 (insn, operands);

        case GE:
          if (pattern394 (x25) != 0
              || !
#line 7601 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_286 (insn, operands);

        case LT:
          if (pattern394 (x25) != 0
              || !
#line 7601 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_287 (insn, operands);

        case GT:
          if (pattern394 (x25) != 0
              || !
#line 7601 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_288 (insn, operands);

        case LE:
          if (pattern394 (x25) != 0
              || !
#line 7601 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_289 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (peep2_current_count < 2
          || pattern107 (x2, 
36, 
E_CCmode) != 0)
        return NULL;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_QImode))
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (pattern215 (x5) != 0)
        return NULL;
      x14 = XEXP (x4, 0);
      switch (GET_MODE (x14))
        {
        case E_HImode:
          if (!register_operand (x14, E_HImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern384 (x13, 
E_HImode))
            {
            case 0:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_294 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_295 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern385 (x13, 
E_HImode) != 0
              || !
#line 10343 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_309 (insn, operands);

        case E_SImode:
          if (!register_operand (x14, E_SImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern384 (x13, 
E_SImode))
            {
            case 0:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_296 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_297 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern385 (x13, 
E_SImode) != 0
              || !
#line 10343 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_310 (insn, operands);

        case E_PSImode:
          if (!register_operand (x14, E_PSImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern384 (x13, 
E_PSImode))
            {
            case 0:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_298 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_299 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern385 (x13, 
E_PSImode) != 0
              || !
#line 10343 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_311 (insn, operands);

        case E_HQmode:
          if (!register_operand (x14, E_HQmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern384 (x13, 
E_HQmode))
            {
            case 0:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_300 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_301 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern385 (x13, 
E_HQmode) != 0
              || !
#line 10343 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_312 (insn, operands);

        case E_HAmode:
          if (!register_operand (x14, E_HAmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern384 (x13, 
E_HAmode))
            {
            case 0:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_302 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_303 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern385 (x13, 
E_HAmode) != 0
              || !
#line 10343 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_313 (insn, operands);

        case E_SQmode:
          if (!register_operand (x14, E_SQmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern384 (x13, 
E_SQmode))
            {
            case 0:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_304 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_305 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern385 (x13, 
E_SQmode) != 0
              || !
#line 10343 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_314 (insn, operands);

        case E_SAmode:
          if (!register_operand (x14, E_SAmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern384 (x13, 
E_SAmode))
            {
            case 0:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_306 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7794 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_307 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern385 (x13, 
E_SAmode) != 0
              || !
#line 10343 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_315 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
